__afterburn_cpu = 0x1000
CPU_CR_OFFSET = 0
CPU_KR_OFFSET = 1024
CPU_RR_OFFSET = 1088
CPU_BANKED_OFFSET = 1152
CPU_PSR_OFFSET = 1408
CPU_IRQ_PENDING_OFFSET = 1416
CPU_IN_SERVICE_IRQ_OFFSET = 1420
CPU_CURRENT_BANK_OFFSET = 1424
CPU_CFLE_OFFSET = 1428

.proc burn_deliver_interrupt
burn_deliver_interrupt:
	/* check psr.i */
	mov r5=__afterburn_cpu+CPU_PSR_OFFSET
	;;
	ld8 r5=[r5]
	;;
	tbit.nz p63,p0=r5,14
	;;

	/* check cr.ivr > in_service_irq */
(p63)	mov r5=__afterburn_cpu+CPU_CR_OFFSET+8*65
(p63)	mov r6=__afterburn_cpu+CPU_IN_SERVICE_IRQ_OFFSET
	;;
(p63)	ld8 r5=[r5]
(p63)	ld4 r6=[r6]
	;;
(p63)	cmp.gt p63,p0=r5,r6	
	;;

	/* check (cr.ivr >> 4) > (tpr >> 4) - includes mmi bit */
(p63)	mov r6=__afterburn_cpu+CPU_CR_OFFSET+8*66
	;;
(p63)	ld8 r6=[r6]
(p63)	shr.u r5=r5,4
	;;
(p63)	shr.u r6=r6,4
	;;
(p63)	cmp.gt p63,p0=r5,r6
	;;

	/* deliver interrupt via hypervisor */
(p63)	break 0x80021
	mov pr=r7,-1
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endp burn_deliver_interrupt	
	
.macro __afterburn_check_interrupts
	mov r5=__afterburn_cpu+CPU_IRQ_PENDING_OFFSET
	;;
	ld4 r5=[r5]
	mov r7=pr
	;;
	cmp.ne p63,p0=r5,r0
(p63)	br.spnt.many burn_deliver_interrupt
	;;
	mov pr=r7,-1
	;;
	mov b2=r4
	br.sptk.many b2
	;;
.endm

.global burn_enable_interrupts
.proc burn_enable_interrupts
burn_enable_interrupts:
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	nop.m 0x0
	;;
	mov r6=__afterburn_cpu+CPU_PSR_OFFSET
	;;
	ld8 r5=[r6]
	;;
	dep r5=-1,r5,14,1
	;;
	st8 [r6]=r5
	add r4=0x10,r4
	__afterburn_check_interrupts
.endp burn_enable_interrupts
