.macro __afterburn_call_0_0_m pr,instr
{.mib
	\instr
	nop.i 0x0
	nop.b 0x0
}
	nop.m 0x0
.endm

.macro __afterburn_call_0_0_b pr,instr
{.mib
	nop.m 0x0
	nop.i 0x0
	\instr
}
	nop.m 0x0
.endm

.macro __afterburn_call_1_0 pr,instr
{.mii
(\pr)	\instr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.b 0x0
}
(\pr)	nop.m 0x0
.endm

.macro __afterburn_call_0_1 pr,instr
{.mib
(\pr)	\instr
(\pr)	nop.i 0x0
(\pr)	nop.b 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endm

.macro __afterburn_call_1_1 pr,instr
{.mii
(\pr)	\instr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.b 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endm

.macro __afterburn_call_2_0 pr,instr
{.mii
(\pr)	\instr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.b 0x0
}
(\pr)	nop.m 0x0
.endm

.macro __afterburn_call_3_0 pr,instr
{.mmi
(\pr)	\instr
(\pr)	nop.m 0x0
(\pr)	nop.i 0x0
}
{.mmb
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.b 0x0
}
(\pr)	nop.m 0x0
.endm

/* don't need to come back! */
.macro emul_rfi
	rfi
.endm

.macro emul_fc pr=p0,src
(\pr)	fc \src
.endm

.macro emul_bsw_0
	__afterburn_call_0_0_b p0,bsw.0
.endm

.macro emul_bsw_1
	__afterburn_call_0_0_b p0,bsw.1
.endm

.macro emul_cover
	__afterburn_call_0_0_b p0,cover
.endm

.macro emul_thash pr=p0,dst,src
	__afterburn_call_1_1 \pr,"thash \dst=\src"
.endm

.macro emul_ttag pr=p0,dst,src
	__afterburn_call_1_1 \pr,"ttag \dst=\src"
.endm

.macro emul_tpa pr=p0,dst,src
	__afterburn_call_1_1 \pr,"tpa \dst=\src"
.endm

.macro emul_write_psr pr=p0,src
	__afterburn_call_1_0 \pr,"mov psr.l=\src"
.endm

.macro emul_write_rr pr=p0,rr,src
	__afterburn_call_2_0 \pr,"mov rr[\rr]=\src"
.endm


/* TLB management operations are multiplexed over burn_tlbop
   since they are all routed to the hypervisor MM subsystem */

.macro emul_itc_d pr=p0,src
	__afterburn_call_3_0 \pr,"itc.d \src"
.endm

.macro emul_itr_d pr=p0,dtr,src
	__afterburn_call_3_0 \pr,"itr.d dtr[\dtr]=\src"
.endm

.macro emul_itc_i pr=p0,src
	__afterburn_call_3_0 \pr,"itc.i \src"
.endm

.macro emul_itr_i pr=p0,itr,src
	__afterburn_call_3_0 \pr,"itr.i itr[\itr]=\src"
.endm

.macro emul_ptc_l pr=p0,va,sz
	__afterburn_call_3_0 \pr,"ptc.l \va,\sz"
.endm

.macro emul_ptc_g pr=p0,va,sz
	__afterburn_call_3_0 \pr,"ptc.g \va,\sz"
.endm

.macro emul_ptc_ga pr=p0,va,sz
	__afterburn_call_3_0 \pr,"ptc.ga \va,\sz"
.endm

.macro emul_ptr_d pr=p0,va,sz
	__afterburn_call_3_0 \pr,"ptr.d \va,\sz"
.endm

.macro emul_ptr_i pr=p0,va,sz
	__afterburn_call_3_0 \pr,"ptr.i \va,\sz"
.endm

.macro emul_ptc_e pr=p0,src
	__afterburn_call_1_0 \pr,"ptc.e \src"
.endm


/* remaining ones are trivial enough to be implemented inline */

/* XXX assumes r27-r31 are scratch */
.macro emul_epc
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.i 0x0
	epc
{
	.mii
	nop.m 0x0
	nop.i 0x0
	nop.i 0x0
}
	nop.m 0x0
	nop.i 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0	
.endm

.macro unepc
{.mii
	nop.m 0x0
	nop.i 0x0
	nop.i 0x0
}
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
	nop.m 0x0
	nop.m 0x0
	nop.i 0x0
.endm

.macro emul_read_cr pr=p0,dst,cr
.if \cr == 65
	__afterburn_call_0_1 \pr,"mov \dst=cr.ivr"
.else
(\pr)	mov \dst=cr\cr
(\pr)	nop.m 0x0
.endif
.endm

.macro emul_write_cr pr=p0,cr,src
.if \cr == 1
	__afterburn_call_1_0 \pr,"mov cr.itm=\src"
.else
{.mii
(\pr)	mov cr\cr=\src
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endif
.endm

.macro emul_read_kr pr=p0,dst,kr
(\pr)	mov \dst=ar.k\kr
(\pr)	nop.m 0x0
.endm

.macro emul_write_kr pr=p0,kr,src
{.mii
(\pr)	mov ar.k\kr=\src
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endm

.macro emul_write_itc pr=p0,src
(\pr)	mov ar.itc=\src
.endm

.macro emul_read_rr pr=p0,dst,rr
(\pr)	mov \dst=rr[\rr]
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endm

.macro emul_read_psr pr=p0,dst
{.mii
(\pr)	mov \dst=psr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.i 0x0
(\pr)	nop.m 0x0
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
.endm

# ignore pk, dfl, sp, pp, di, si
.macro emul_ssm pr=p0,mask
#.if \mask & ((1<<13)|(1<<17))
#{.mii
#(\pr)	ssm \mask
#(\pr)	nop.i 0x0
#(\pr)	nop.i 0x0
#}
#(\pr)	nop.m 0x0
#.if \mask & (1<<13)
#(\pr)	nop.i 0x0
#.endif
#.if \mask & (1<<17)
#(\pr)	nop.i 0x0
#.endif
#(\pr)	nop.m 0x0
#(\pr)	nop.m 0x0
#.if \mask & ((1<<14)|(1<<19))
#	__afterburn_call_0_0_m \pr,"nop.m 0x0"
#.endif
#.elseif \mask & ((1<<14)|(1<<19))
#	__afterburn_call_0_0_m \pr,"ssm \mask"
#.else
(\pr)	ssm \mask
#.endif
#.if \mask & 0x3f
#	nop.m 0x0
#.endif
.endm

# ignore pk, dfl, sp, pp, di, si
.macro emul_rsm pr=p0,mask
#.if \mask & ((1<<13)|(1<<14)|(1<<17)|(1<<19))
#{.mii
#(\pr)	rsm \mask
#(\pr)	nop.i 0x0
#(\pr)	nop.i 0x0
#}
#(\pr)	nop.m 0x0
#.if \mask & (1<<13)
#(\pr)	nop.i 0x0
#.endif
#.if \mask & (1<<14)
#(\pr)	nop.i 0x0
#.endif
#.if \mask & (1<<17)
#(\pr)	nop.i 0x0
#.endif
#.if \mask & (1<<19)
#(\pr)	nop.i 0x0
#.endif
#(\pr)	nop.m 0x0
#(\pr)	nop.m 0x0
#.else
(\pr)	rsm \mask
#.endif
#.if \mask & 0x3f
#(\pr)	nop.m 0x0
#.endif
.endm

.macro emul_srlz_d pr=p0
(\pr)	srlz.d
.endm

.macro emul_srlz_i pr=p0
(\pr)	srlz.i
.endm

.macro real_cover
	cover
.endm

.macro emul_st8_spill_r pr=p0,idx,incr,reg
{.mii
(\pr)	st8.spill [\idx]=r\reg,\incr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.i 0x0
(\pr)	nop.m 0x0
.endm

.macro emul_ld8_fill_r pr=p0,idx,incr,reg
{.mii
(\pr)	ld8.fill r\reg=[\idx],\incr
(\pr)	nop.i 0x0
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
(\pr)	nop.i 0x0
(\pr)	nop.m 0x0
.endm

.macro emul_read_b2 pr=p0,dst
(\pr)	mov \dst=b2
(\pr)	nop.m 0x0
.endm

.macro emul_write_b2 pr=p0,src
{.mii
(\pr)	nop.m 0x0	
(\pr)	mov b2=\src
(\pr)	nop.i 0x0
}
(\pr)	nop.m 0x0
(\pr)	nop.m 0x0
.endm
