#if !defined _TRACE_H && defined IDE_TRACE
#define _TRACE_H
/* tracing ide requests */

#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <stdint.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <inttypes.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "UserPrint.h"

#define IDE_TRACE_FILENAME "/tmp/ide.trace"
#define IDE_TRACE_FIFO_FILENAME "/tmp/ide_trace_ctl"

int ide_setup_trace(char *);
void ide_start_trace(void);
int ide_do_trace(int flags, uint64_t block_number, uint16_t blocks);
void ide_stop_trace(void);

#define IDE_TRACE_READ  0x1
#define IDE_TRACE_WRITE 0x2

struct ide_trace
{
        uint32_t flags;
        uint32_t blocks;
        uint64_t block_number;
} __attribute__((packed));


#endif /* _TRACE_H && IDE_TRACE */
