#ifndef _CMD680_H_
#define _CMD680_H_

#include "cmd680_types.reg.h"

#include <io/pci_conf.h>

static inline union cache_line read_cache_line(bus_space_t bus) {
	union cache_line foo;
	foo.data = pci_conf_read_8(bus, 12);
	return foo;
}

#define READ_CACHE_LINE() read_cache_line(dthis->pciconf)

static inline void write_cache_line(bus_space_t bus, union cache_line foo) {
	return pci_conf_write_8 (bus, (12), foo.data);
}

#define WRITE_CACHE_LINE(foo) write_cache_line(dthis->pciconf, foo)

static inline union scsc read_scsc(bus_space_t bus) {
	union scsc foo;
	foo.data = pci_conf_read_8(bus, 138);
	return foo;
}

#define READ_SCSC() read_scsc(dthis->pciconf)

static inline void write_scsc(bus_space_t bus, union scsc foo) {
	return pci_conf_write_8 (bus, (138), foo.data);
}

#define WRITE_SCSC(foo) write_scsc(dthis->pciconf, foo)

static inline union ultra read_ultra(bus_space_t bus) {
	union ultra foo;
	foo.data = pci_conf_read_16(bus, 172);
	return foo;
}

#define READ_ULTRA() read_ultra(dthis->pciconf)

static inline void write_ultra(bus_space_t bus, union ultra foo) {
	return pci_conf_write_16 (bus, (172), foo.data);
}

#define WRITE_ULTRA(foo) write_ultra(dthis->pciconf, foo)

static inline union modepci read_modepci(bus_space_t bus) {
	union modepci foo;
	foo.data = pci_conf_read_8(bus, 128);
	return foo;
}

#define READ_MODEPCI() read_modepci(dthis->pciconf)

static inline void write_modepci(bus_space_t bus, union modepci foo) {
	return pci_conf_write_8 (bus, (128), foo.data);
}

#define WRITE_MODEPCI(foo) write_modepci(dthis->pciconf, foo)

static inline union multi_drive_0 read_multi_drive_0(bus_space_t bus) {
	union multi_drive_0 foo;
	foo.data = pci_conf_read_16(bus, 168);
	return foo;
}

#define READ_MULTI_DRIVE_0() read_multi_drive_0(dthis->pciconf)

static inline void write_multi_drive_0(bus_space_t bus, union multi_drive_0 foo) {
	return pci_conf_write_16 (bus, (168), foo.data);
}

#define WRITE_MULTI_DRIVE_0(foo) write_multi_drive_0(dthis->pciconf, foo)

static inline union multi_drive_1 read_multi_drive_1(bus_space_t bus) {
	union multi_drive_1 foo;
	foo.data = pci_conf_read_16(bus, 184);
	return foo;
}

#define READ_MULTI_DRIVE_1() read_multi_drive_1(dthis->pciconf)

static inline void write_multi_drive_1(bus_space_t bus, union multi_drive_1 foo) {
	return pci_conf_write_16 (bus, (184), foo.data);
}

#define WRITE_MULTI_DRIVE_1(foo) write_multi_drive_1(dthis->pciconf, foo)

static inline void print_cache_line ( union cache_line reg ) {	UserPrint("Debug cache_line - 0x%x\n", reg.data);}

static inline void print_scsc ( union scsc reg ) {	UserPrint("Debug scsc - 0x%x\n", reg.data);}

static inline void print_ultra ( union ultra reg ) {	UserPrint("Debug ultra - 0x%x\n", reg.data);}

static inline void print_modepci ( union modepci reg ) {	UserPrint("Debug modepci - 0x%x\n", reg.data);}

static inline void print_multi_drive_0 ( union multi_drive_0 reg ) {	UserPrint("Debug multi_drive_0 - 0x%x\n", reg.data);}

static inline void print_multi_drive_1 ( union multi_drive_1 reg ) {	UserPrint("Debug multi_drive_1 - 0x%x\n", reg.data);}

#endif /* _CMD680_H_ */
