#include <driver_interface.h>
#include "cmd680_chipset.h"
#include "cmd680.reg.h"

void
cmd680_init(dide_t * dthis)
{
	union ultra ultra;
	union scsc scsc;
	union modepci modepci;
	union cache_line cache_line;

	/* This is really, really, really evil and broken.
	   This is usually set by the system (bios or os),
	   however this chipset is broken and needs `1' in 
	   there, so we do it.
	*/
	cache_line.data = 1;
	WRITE_CACHE_LINE(cache_line);

	/* Now we read the undocumented SCSC register,
	   which seems to affect bus timings, and force it
	   into 133 mode 
	*/

	scsc = READ_SCSC();

	if ((scsc.data & 0x30) == 0x0) {
	  /* Turn on 133 mode */
	  scsc.data |= 0x10;
	  /* Now we reread to check it is right */
	  WRITE_SCSC(scsc);
	}

	ultra = READ_ULTRA();
	modepci = READ_MODEPCI();

	/* We set modepci to 3 for drive 0 on ch 0.
	   This mode is used for UDMA afaict */

	modepci.data &= ~0x3;
	modepci.data = 0x3;
	WRITE_MODEPCI(modepci);

	/* Setup multiword dma magic register.
	   We probably don't need this as we use udma5 */
	/* Drive 1 */
	WRITE_MULTI_DRIVE_1((union multi_drive_1) (uint16_t) 0x10c1);
	/* Drive 0 */
	WRITE_MULTI_DRIVE_0((union multi_drive_0) (uint16_t) 0x10c1);
	
	/* Now set the udma timing register */
	ultra.data &= ~0x3f;
	ultra.data |= (((scsc.data & 0x30) != 0x00) ? 0x02: 0x01);
	WRITE_ULTRA(ultra);

}

