#ifndef _IDE_BM_H_
#define _IDE_BM_H_

#include "ide_bm_types.reg.h"

#include <io/io.h>

static uintptr_t offset_array_idebm_command_read[2] = {
	0,
	8,
};

static inline union idebm_command read_idebm_command(int idx, bus_space_t bus) {
	union idebm_command foo;
	foo.data = io_read_8(bus, offset_array_idebm_command_read[idx]);
	return foo;
}

#define READ_IDEBM_COMMAND(idx) read_idebm_command(idx, dthis->bmaster_port)

static uintptr_t offset_array_idebm_command_write[2] = {
	0,
	8,
};

static inline void write_idebm_command(int idx, bus_space_t bus, union idebm_command foo) {
	return io_write_8 (bus, (offset_array_idebm_command_write[idx]), foo.data);
}

#define WRITE_IDEBM_COMMAND(idx, foo) write_idebm_command(idx, dthis->bmaster_port, foo)

static uintptr_t offset_array_idebm_status_read[2] = {
	2,
	10,
};

static inline union idebm_status read_idebm_status(int idx, bus_space_t bus) {
	union idebm_status foo;
	foo.data = io_read_8(bus, offset_array_idebm_status_read[idx]);
	return foo;
}

#define READ_IDEBM_STATUS(idx) read_idebm_status(idx, dthis->bmaster_port)

static uintptr_t offset_array_idebm_status_write[2] = {
	2,
	10,
};

static inline void write_idebm_status(int idx, bus_space_t bus, union idebm_status foo) {
	return io_write_8 (bus, (offset_array_idebm_status_write[idx]), foo.data);
}

#define WRITE_IDEBM_STATUS(idx, foo) write_idebm_status(idx, dthis->bmaster_port, foo)

static uintptr_t offset_array_idebm_prd_read[2] = {
	4,
	12,
};

static inline union idebm_prd read_idebm_prd(int idx, bus_space_t bus) {
	union idebm_prd foo;
	foo.data = io_read_32(bus, offset_array_idebm_prd_read[idx]);
	return foo;
}

#define READ_IDEBM_PRD(idx) read_idebm_prd(idx, dthis->bmaster_port)

static uintptr_t offset_array_idebm_prd_write[2] = {
	4,
	12,
};

static inline void write_idebm_prd(int idx, bus_space_t bus, union idebm_prd foo) {
	return io_write_32 (bus, (offset_array_idebm_prd_write[idx]), foo.data);
}

#define WRITE_IDEBM_PRD(idx, foo) write_idebm_prd(idx, dthis->bmaster_port, foo)

static inline void print_idebm_command ( union idebm_command reg ) {	UserPrint("Debug idebm_command - 0x%x\n", reg.data);	if (reg.r.start_stop != 0) {
		UserPrint("\tstart_stop: %x\n", reg.r.start_stop);
	}
	if (reg.r.read_write != 0) {
		UserPrint("\tread_write: %x\n", reg.r.read_write);
	}
}

static inline void print_idebm_status ( union idebm_status reg ) {	UserPrint("Debug idebm_status - 0x%x\n", reg.data);	if (reg.r.active != 0) {
		UserPrint("\tactive: %x\n", reg.r.active);
	}
	if (reg.r.error != 0) {
		UserPrint("\terror: %x\n", reg.r.error);
	}
	if (reg.r.interrupt != 0) {
		UserPrint("\tinterrupt: %x\n", reg.r.interrupt);
	}
	if (reg.r.drive_0_cap != 0) {
		UserPrint("\tdrive_0_cap: %x\n", reg.r.drive_0_cap);
	}
	if (reg.r.drive_1_cap != 0) {
		UserPrint("\tdrive_1_cap: %x\n", reg.r.drive_1_cap);
	}
	if (reg.r.simplex != 0) {
		UserPrint("\tsimplex: %x\n", reg.r.simplex);
	}
}

static inline void print_idebm_prd ( union idebm_prd reg ) {	UserPrint("Debug idebm_prd - 0x%x\n", reg.data);	if (reg.r.addr != 0) {
		UserPrint("\taddr: %x\n", reg.r.addr);
	}
}

#endif /* _IDE_BM_H_ */
