#ifndef _DP83820_H_
#define _DP83820_H_

#include "dp83820_types.reg.h"

#include <io/io.h>

static inline union cr read_cr(bus_space_t bus) {
	union cr foo;
	foo.data = io_read_32(bus, 0);
	return foo;
}

#define READ_CR() read_cr(dthis->csr)

static inline void write_cr(bus_space_t bus, union cr foo) {
	return io_write_32 (bus, (0), foo.data);
}

#define WRITE_CR(foo) write_cr(dthis->csr, foo)

static inline union cfg read_cfg(bus_space_t bus) {
	union cfg foo;
	foo.data = io_read_32(bus, 4);
	return foo;
}

#define READ_CFG() read_cfg(dthis->csr)

static inline void write_cfg(bus_space_t bus, union cfg foo) {
	return io_write_32 (bus, (4), foo.data);
}

#define WRITE_CFG(foo) write_cfg(dthis->csr, foo)

static inline union ptscr read_ptscr(bus_space_t bus) {
	union ptscr foo;
	foo.data = io_read_32(bus, 12);
	return foo;
}

#define READ_PTSCR() read_ptscr(dthis->csr)

static inline void write_ptscr(bus_space_t bus, union ptscr foo) {
	return io_write_32 (bus, (12), foo.data);
}

#define WRITE_PTSCR(foo) write_ptscr(dthis->csr, foo)

static inline union isr read_isr(bus_space_t bus) {
	union isr foo;
	foo.data = io_read_32(bus, 16);
	return foo;
}

#define READ_ISR() read_isr(dthis->csr)

static inline void write_isr(bus_space_t bus, union isr foo) {
	return io_write_32 (bus, (16), foo.data);
}

#define WRITE_ISR(foo) write_isr(dthis->csr, foo)

static inline union imr read_imr(bus_space_t bus) {
	union imr foo;
	foo.data = io_read_32(bus, 20);
	return foo;
}

#define READ_IMR() read_imr(dthis->csr)

static inline void write_imr(bus_space_t bus, union imr foo) {
	return io_write_32 (bus, (20), foo.data);
}

#define WRITE_IMR(foo) write_imr(dthis->csr, foo)

static inline union ier read_ier(bus_space_t bus) {
	union ier foo;
	foo.data = io_read_32(bus, 24);
	return foo;
}

#define READ_IER() read_ier(dthis->csr)

static inline void write_ier(bus_space_t bus, union ier foo) {
	return io_write_32 (bus, (24), foo.data);
}

#define WRITE_IER(foo) write_ier(dthis->csr, foo)

static inline union ihr read_ihr(bus_space_t bus) {
	union ihr foo;
	foo.data = io_read_32(bus, 28);
	return foo;
}

#define READ_IHR() read_ihr(dthis->csr)

static inline void write_ihr(bus_space_t bus, union ihr foo) {
	return io_write_32 (bus, (28), foo.data);
}

#define WRITE_IHR(foo) write_ihr(dthis->csr, foo)

static inline union txdp read_txdp(bus_space_t bus) {
	union txdp foo;
	foo.data = io_read_32(bus, 32);
	return foo;
}

#define READ_TXDP() read_txdp(dthis->csr)

static inline void write_txdp(bus_space_t bus, union txdp foo) {
	return io_write_32 (bus, (32), foo.data);
}

#define WRITE_TXDP(foo) write_txdp(dthis->csr, foo)

static inline union txdp_hi read_txdp_hi(bus_space_t bus) {
	union txdp_hi foo;
	foo.data = io_read_32(bus, 36);
	return foo;
}

#define READ_TXDP_HI() read_txdp_hi(dthis->csr)

static inline void write_txdp_hi(bus_space_t bus, union txdp_hi foo) {
	return io_write_32 (bus, (36), foo.data);
}

#define WRITE_TXDP_HI(foo) write_txdp_hi(dthis->csr, foo)

static inline union txcfg read_txcfg(bus_space_t bus) {
	union txcfg foo;
	foo.data = io_read_32(bus, 40);
	return foo;
}

#define READ_TXCFG() read_txcfg(dthis->csr)

static inline void write_txcfg(bus_space_t bus, union txcfg foo) {
	return io_write_32 (bus, (40), foo.data);
}

#define WRITE_TXCFG(foo) write_txcfg(dthis->csr, foo)

static inline union rxdp read_rxdp(bus_space_t bus) {
	union rxdp foo;
	foo.data = io_read_32(bus, 48);
	return foo;
}

#define READ_RXDP() read_rxdp(dthis->csr)

static inline void write_rxdp(bus_space_t bus, union rxdp foo) {
	return io_write_32 (bus, (48), foo.data);
}

#define WRITE_RXDP(foo) write_rxdp(dthis->csr, foo)

static inline union rxdp_hi read_rxdp_hi(bus_space_t bus) {
	union rxdp_hi foo;
	foo.data = io_read_32(bus, 52);
	return foo;
}

#define READ_RXDP_HI() read_rxdp_hi(dthis->csr)

static inline void write_rxdp_hi(bus_space_t bus, union rxdp_hi foo) {
	return io_write_32 (bus, (52), foo.data);
}

#define WRITE_RXDP_HI(foo) write_rxdp_hi(dthis->csr, foo)

static inline union rxcfg read_rxcfg(bus_space_t bus) {
	union rxcfg foo;
	foo.data = io_read_32(bus, 56);
	return foo;
}

#define READ_RXCFG() read_rxcfg(dthis->csr)

static inline void write_rxcfg(bus_space_t bus, union rxcfg foo) {
	return io_write_32 (bus, (56), foo.data);
}

#define WRITE_RXCFG(foo) write_rxcfg(dthis->csr, foo)

static inline union pqcr read_pqcr(bus_space_t bus) {
	union pqcr foo;
	foo.data = io_read_32(bus, 60);
	return foo;
}

#define READ_PQCR() read_pqcr(dthis->csr)

static inline void write_pqcr(bus_space_t bus, union pqcr foo) {
	return io_write_32 (bus, (60), foo.data);
}

#define WRITE_PQCR(foo) write_pqcr(dthis->csr, foo)

static inline union wcsr read_wcsr(bus_space_t bus) {
	union wcsr foo;
	foo.data = io_read_32(bus, 64);
	return foo;
}

#define READ_WCSR() read_wcsr(dthis->csr)

static inline void write_wcsr(bus_space_t bus, union wcsr foo) {
	return io_write_32 (bus, (64), foo.data);
}

#define WRITE_WCSR(foo) write_wcsr(dthis->csr, foo)

static inline union pcr read_pcr(bus_space_t bus) {
	union pcr foo;
	foo.data = io_read_32(bus, 68);
	return foo;
}

#define READ_PCR() read_pcr(dthis->csr)

static inline void write_pcr(bus_space_t bus, union pcr foo) {
	return io_write_32 (bus, (68), foo.data);
}

#define WRITE_PCR(foo) write_pcr(dthis->csr, foo)

static inline union rfcr read_rfcr(bus_space_t bus) {
	union rfcr foo;
	foo.data = io_read_32(bus, 72);
	return foo;
}

#define READ_RFCR() read_rfcr(dthis->csr)

static inline void write_rfcr(bus_space_t bus, union rfcr foo) {
	return io_write_32 (bus, (72), foo.data);
}

#define WRITE_RFCR(foo) write_rfcr(dthis->csr, foo)

static inline union rfdr read_rfdr(bus_space_t bus) {
	union rfdr foo;
	foo.data = io_read_32(bus, 76);
	return foo;
}

#define READ_RFDR() read_rfdr(dthis->csr)

static inline void write_rfdr(bus_space_t bus, union rfdr foo) {
	return io_write_32 (bus, (76), foo.data);
}

#define WRITE_RFDR(foo) write_rfdr(dthis->csr, foo)

static inline union vrcr read_vrcr(bus_space_t bus) {
	union vrcr foo;
	foo.data = io_read_32(bus, 188);
	return foo;
}

#define READ_VRCR() read_vrcr(dthis->csr)

static inline void write_vrcr(bus_space_t bus, union vrcr foo) {
	return io_write_32 (bus, (188), foo.data);
}

#define WRITE_VRCR(foo) write_vrcr(dthis->csr, foo)

static inline union vtcr read_vtcr(bus_space_t bus) {
	union vtcr foo;
	foo.data = io_read_32(bus, 192);
	return foo;
}

#define READ_VTCR() read_vtcr(dthis->csr)

static inline void write_vtcr(bus_space_t bus, union vtcr foo) {
	return io_write_32 (bus, (192), foo.data);
}

#define WRITE_VTCR(foo) write_vtcr(dthis->csr, foo)

static inline union ccsr read_ccsr(bus_space_t bus) {
	union ccsr foo;
	foo.data = io_read_32(bus, 204);
	return foo;
}

#define READ_CCSR() read_ccsr(dthis->csr)

static inline void write_ccsr(bus_space_t bus, union ccsr foo) {
	return io_write_32 (bus, (204), foo.data);
}

#define WRITE_CCSR(foo) write_ccsr(dthis->csr, foo)

static inline union mibc read_mibc(bus_space_t bus) {
	union mibc foo;
	foo.data = io_read_32(bus, 92);
	return foo;
}

#define READ_MIBC() read_mibc(dthis->csr)

static inline void write_mibc(bus_space_t bus, union mibc foo) {
	return io_write_32 (bus, (92), foo.data);
}

#define WRITE_MIBC(foo) write_mibc(dthis->csr, foo)

static inline union mib_rxerroredpkts read_mib_rxerroredpkts(bus_space_t bus) {
	union mib_rxerroredpkts foo;
	foo.data = io_read_16(bus, 96);
	return foo;
}

#define READ_MIB_RXERROREDPKTS() read_mib_rxerroredpkts(dthis->csr)

static inline union mib_rxfcserrors read_mib_rxfcserrors(bus_space_t bus) {
	union mib_rxfcserrors foo;
	foo.data = io_read_16(bus, 100);
	return foo;
}

#define READ_MIB_RXFCSERRORS() read_mib_rxfcserrors(dthis->csr)

static inline union mib_rxmsdpkterrors read_mib_rxmsdpkterrors(bus_space_t bus) {
	union mib_rxmsdpkterrors foo;
	foo.data = io_read_16(bus, 104);
	return foo;
}

#define READ_MIB_RXMSDPKTERRORS() read_mib_rxmsdpkterrors(dthis->csr)

static inline union mib_rxfaerrors read_mib_rxfaerrors(bus_space_t bus) {
	union mib_rxfaerrors foo;
	foo.data = io_read_16(bus, 108);
	return foo;
}

#define READ_MIB_RXFAERRORS() read_mib_rxfaerrors(dthis->csr)

static inline union mib_rxsymbolerrors read_mib_rxsymbolerrors(bus_space_t bus) {
	union mib_rxsymbolerrors foo;
	foo.data = io_read_16(bus, 112);
	return foo;
}

#define READ_MIB_RXSYMBOLERRORS() read_mib_rxsymbolerrors(dthis->csr)

static inline union mib_rxframetoolong read_mib_rxframetoolong(bus_space_t bus) {
	union mib_rxframetoolong foo;
	foo.data = io_read_16(bus, 116);
	return foo;
}

#define READ_MIB_RXFRAMETOOLONG() read_mib_rxframetoolong(dthis->csr)

static inline union mib_rxirlerrors read_mib_rxirlerrors(bus_space_t bus) {
	union mib_rxirlerrors foo;
	foo.data = io_read_16(bus, 120);
	return foo;
}

#define READ_MIB_RXIRLERRORS() read_mib_rxirlerrors(dthis->csr)

static inline union mib_rxbadopcodes read_mib_rxbadopcodes(bus_space_t bus) {
	union mib_rxbadopcodes foo;
	foo.data = io_read_16(bus, 124);
	return foo;
}

#define READ_MIB_RXBADOPCODES() read_mib_rxbadopcodes(dthis->csr)

static inline union mib_rxpauseframes read_mib_rxpauseframes(bus_space_t bus) {
	union mib_rxpauseframes foo;
	foo.data = io_read_16(bus, 128);
	return foo;
}

#define READ_MIB_RXPAUSEFRAMES() read_mib_rxpauseframes(dthis->csr)

static inline union mib_txpauseframes read_mib_txpauseframes(bus_space_t bus) {
	union mib_txpauseframes foo;
	foo.data = io_read_16(bus, 132);
	return foo;
}

#define READ_MIB_TXPAUSEFRAMES() read_mib_txpauseframes(dthis->csr)

static inline union mib_txsqeerrors read_mib_txsqeerrors(bus_space_t bus) {
	union mib_txsqeerrors foo;
	foo.data = io_read_8(bus, 136);
	return foo;
}

#define READ_MIB_TXSQEERRORS() read_mib_txsqeerrors(dthis->csr)

static inline void print_cr ( union cr reg ) {	UserPrint("Debug cr - 0x%x\n", reg.data);	if (reg.r.txe != 0) {
		UserPrint("\ttxe: %x\n", reg.r.txe);
	}
	if (reg.r.rxe != 0) {
		UserPrint("\trxe: %x\n", reg.r.rxe);
	}
	if (reg.r.rst != 0) {
		UserPrint("\trst: %x\n", reg.r.rst);
	}
}

static inline void print_cfg ( union cfg reg ) {	UserPrint("Debug cfg - 0x%x\n", reg.data);	if (reg.r.bem != 0) {
		UserPrint("\tbem: %x\n", reg.r.bem);
	}
	if (reg.r.ext_125 != 0) {
		UserPrint("\text_125: %x\n", reg.r.ext_125);
	}
	if (reg.r.brom_dis != 0) {
		UserPrint("\tbrom_dis: %x\n", reg.r.brom_dis);
	}
	if (reg.r.pesel != 0) {
		UserPrint("\tpesel: %x\n", reg.r.pesel);
	}
	if (reg.r.exd != 0) {
		UserPrint("\texd: %x\n", reg.r.exd);
	}
	if (reg.r.pow != 0) {
		UserPrint("\tpow: %x\n", reg.r.pow);
	}
	if (reg.r.sb != 0) {
		UserPrint("\tsb: %x\n", reg.r.sb);
	}
	if (reg.r.reqalg != 0) {
		UserPrint("\treqalg: %x\n", reg.r.reqalg);
	}
	if (reg.r.extsts_en != 0) {
		UserPrint("\textsts_en: %x\n", reg.r.extsts_en);
	}
	if (reg.r.phy_dis != 0) {
		UserPrint("\tphy_dis: %x\n", reg.r.phy_dis);
	}
	if (reg.r.phy_rst != 0) {
		UserPrint("\tphy_rst: %x\n", reg.r.phy_rst);
	}
	if (reg.r.m64addr != 0) {
		UserPrint("\tm64addr: %x\n", reg.r.m64addr);
	}
	if (reg.r.data64_en != 0) {
		UserPrint("\tdata64_en: %x\n", reg.r.data64_en);
	}
	if (reg.r.pci64_det != 0) {
		UserPrint("\tpci64_det: %x\n", reg.r.pci64_det);
	}
	if (reg.r.t64addr != 0) {
		UserPrint("\tt64addr: %x\n", reg.r.t64addr);
	}
	if (reg.r.mwi_dis != 0) {
		UserPrint("\tmwi_dis: %x\n", reg.r.mwi_dis);
	}
	if (reg.r.mrm_dis != 0) {
		UserPrint("\tmrm_dis: %x\n", reg.r.mrm_dis);
	}
	if (reg.r.tmrtest != 0) {
		UserPrint("\ttmrtest: %x\n", reg.r.tmrtest);
	}
	if (reg.r.pint_dupsts != 0) {
		UserPrint("\tpint_dupsts: %x\n", reg.r.pint_dupsts);
	}
	if (reg.r.pint_lnksts != 0) {
		UserPrint("\tpint_lnksts: %x\n", reg.r.pint_lnksts);
	}
	if (reg.r.pint_spdsts != 0) {
		UserPrint("\tpint_spdsts: %x\n", reg.r.pint_spdsts);
	}
	if (reg.r.auto_1000 != 0) {
		UserPrint("\tauto_1000: %x\n", reg.r.auto_1000);
	}
	if (reg.r.mode_1000 != 0) {
		UserPrint("\tmode_1000: %x\n", reg.r.mode_1000);
	}
	if (reg.r.auto_dup != 0) {
		UserPrint("\tauto_dup: %x\n", reg.r.auto_dup);
	}
	if (reg.r.tbi_en != 0) {
		UserPrint("\ttbi_en: %x\n", reg.r.tbi_en);
	}
	if (reg.r.dupsts != 0) {
		UserPrint("\tdupsts: %x\n", reg.r.dupsts);
	}
	if (reg.r.spdsts != 0) {
		UserPrint("\tspdsts: %x\n", reg.r.spdsts);
	}
	if (reg.r.lnksts != 0) {
		UserPrint("\tlnksts: %x\n", reg.r.lnksts);
	}
}

static inline void print_ptscr ( union ptscr reg ) {	UserPrint("Debug ptscr - 0x%x\n", reg.data);	if (reg.r.eebist_fail != 0) {
		UserPrint("\teebist_fail: %x\n", reg.r.eebist_fail);
	}
	if (reg.r.eebist_en != 0) {
		UserPrint("\teebist_en: %x\n", reg.r.eebist_en);
	}
	if (reg.r.eeload != 0) {
		UserPrint("\teeload: %x\n", reg.r.eeload);
	}
}

static inline void print_isr ( union isr reg ) {	UserPrint("Debug isr - 0x%x\n", reg.data);	if (reg.r.rxok != 0) {
		UserPrint("\trxok: %x\n", reg.r.rxok);
	}
	if (reg.r.rxdesc != 0) {
		UserPrint("\trxdesc: %x\n", reg.r.rxdesc);
	}
	if (reg.r.rxerr != 0) {
		UserPrint("\trxerr: %x\n", reg.r.rxerr);
	}
	if (reg.r.rxearly != 0) {
		UserPrint("\trxearly: %x\n", reg.r.rxearly);
	}
	if (reg.r.rxidle != 0) {
		UserPrint("\trxidle: %x\n", reg.r.rxidle);
	}
	if (reg.r.rxorn != 0) {
		UserPrint("\trxorn: %x\n", reg.r.rxorn);
	}
	if (reg.r.txok != 0) {
		UserPrint("\ttxok: %x\n", reg.r.txok);
	}
	if (reg.r.txdesc != 0) {
		UserPrint("\ttxdesc: %x\n", reg.r.txdesc);
	}
	if (reg.r.txerr != 0) {
		UserPrint("\ttxerr: %x\n", reg.r.txerr);
	}
	if (reg.r.txidle != 0) {
		UserPrint("\ttxidle: %x\n", reg.r.txidle);
	}
	if (reg.r.txurn != 0) {
		UserPrint("\ttxurn: %x\n", reg.r.txurn);
	}
	if (reg.r.mib != 0) {
		UserPrint("\tmib: %x\n", reg.r.mib);
	}
	if (reg.r.swi != 0) {
		UserPrint("\tswi: %x\n", reg.r.swi);
	}
	if (reg.r.pme != 0) {
		UserPrint("\tpme: %x\n", reg.r.pme);
	}
	if (reg.r.phy != 0) {
		UserPrint("\tphy: %x\n", reg.r.phy);
	}
	if (reg.r.hibint != 0) {
		UserPrint("\thibint: %x\n", reg.r.hibint);
	}
	if (reg.r.rxsovr != 0) {
		UserPrint("\trxsovr: %x\n", reg.r.rxsovr);
	}
	if (reg.r.rtabt != 0) {
		UserPrint("\trtabt: %x\n", reg.r.rtabt);
	}
	if (reg.r.rmabt != 0) {
		UserPrint("\trmabt: %x\n", reg.r.rmabt);
	}
	if (reg.r.sserr != 0) {
		UserPrint("\tsserr: %x\n", reg.r.sserr);
	}
	if (reg.r.dperr != 0) {
		UserPrint("\tdperr: %x\n", reg.r.dperr);
	}
	if (reg.r.rxrcmp != 0) {
		UserPrint("\trxrcmp: %x\n", reg.r.rxrcmp);
	}
	if (reg.r.txrcmp != 0) {
		UserPrint("\ttxrcmp: %x\n", reg.r.txrcmp);
	}
}

static inline void print_imr ( union imr reg ) {	UserPrint("Debug imr - 0x%x\n", reg.data);	if (reg.r.rxok != 0) {
		UserPrint("\trxok: %x\n", reg.r.rxok);
	}
	if (reg.r.rxdesc != 0) {
		UserPrint("\trxdesc: %x\n", reg.r.rxdesc);
	}
	if (reg.r.rxerr != 0) {
		UserPrint("\trxerr: %x\n", reg.r.rxerr);
	}
	if (reg.r.rxearly != 0) {
		UserPrint("\trxearly: %x\n", reg.r.rxearly);
	}
	if (reg.r.rxidle != 0) {
		UserPrint("\trxidle: %x\n", reg.r.rxidle);
	}
	if (reg.r.rxorn != 0) {
		UserPrint("\trxorn: %x\n", reg.r.rxorn);
	}
	if (reg.r.txok != 0) {
		UserPrint("\ttxok: %x\n", reg.r.txok);
	}
	if (reg.r.txdesc != 0) {
		UserPrint("\ttxdesc: %x\n", reg.r.txdesc);
	}
	if (reg.r.txerr != 0) {
		UserPrint("\ttxerr: %x\n", reg.r.txerr);
	}
	if (reg.r.txidle != 0) {
		UserPrint("\ttxidle: %x\n", reg.r.txidle);
	}
	if (reg.r.txurn != 0) {
		UserPrint("\ttxurn: %x\n", reg.r.txurn);
	}
	if (reg.r.mib != 0) {
		UserPrint("\tmib: %x\n", reg.r.mib);
	}
	if (reg.r.swi != 0) {
		UserPrint("\tswi: %x\n", reg.r.swi);
	}
	if (reg.r.pme != 0) {
		UserPrint("\tpme: %x\n", reg.r.pme);
	}
	if (reg.r.phy != 0) {
		UserPrint("\tphy: %x\n", reg.r.phy);
	}
	if (reg.r.hibint != 0) {
		UserPrint("\thibint: %x\n", reg.r.hibint);
	}
	if (reg.r.rxsovr != 0) {
		UserPrint("\trxsovr: %x\n", reg.r.rxsovr);
	}
	if (reg.r.rtabt != 0) {
		UserPrint("\trtabt: %x\n", reg.r.rtabt);
	}
	if (reg.r.rmabt != 0) {
		UserPrint("\trmabt: %x\n", reg.r.rmabt);
	}
	if (reg.r.sserr != 0) {
		UserPrint("\tsserr: %x\n", reg.r.sserr);
	}
	if (reg.r.dperr != 0) {
		UserPrint("\tdperr: %x\n", reg.r.dperr);
	}
	if (reg.r.rxrcmp != 0) {
		UserPrint("\trxrcmp: %x\n", reg.r.rxrcmp);
	}
	if (reg.r.txrcmp != 0) {
		UserPrint("\ttxrcmp: %x\n", reg.r.txrcmp);
	}
}

static inline void print_ier ( union ier reg ) {	UserPrint("Debug ier - 0x%x\n", reg.data);}

static inline void print_ihr ( union ihr reg ) {	UserPrint("Debug ihr - 0x%x\n", reg.data);}

static inline void print_txdp ( union txdp reg ) {	UserPrint("Debug txdp - 0x%x\n", reg.data);}

static inline void print_txdp_hi ( union txdp_hi reg ) {	UserPrint("Debug txdp_hi - 0x%x\n", reg.data);}

static inline void print_txcfg ( union txcfg reg ) {	UserPrint("Debug txcfg - 0x%x\n", reg.data);	if (reg.r.drth != 0) {
		UserPrint("\tdrth: %x\n", reg.r.drth);
	}
	if (reg.r.flth != 0) {
		UserPrint("\tflth: %x\n", reg.r.flth);
	}
	if (reg.r.mxdma != 0) {
		UserPrint("\tmxdma: %x\n", reg.r.mxdma);
	}
	if (reg.r.atp != 0) {
		UserPrint("\tatp: %x\n", reg.r.atp);
	}
	if (reg.r.hbi != 0) {
		UserPrint("\thbi: %x\n", reg.r.hbi);
	}
	if (reg.r.csi != 0) {
		UserPrint("\tcsi: %x\n", reg.r.csi);
	}
}

static inline void print_rxdp ( union rxdp reg ) {	UserPrint("Debug rxdp - 0x%x\n", reg.data);}

static inline void print_rxdp_hi ( union rxdp_hi reg ) {	UserPrint("Debug rxdp_hi - 0x%x\n", reg.data);}

static inline void print_rxcfg ( union rxcfg reg ) {	UserPrint("Debug rxcfg - 0x%x\n", reg.data);	if (reg.r.drth != 0) {
		UserPrint("\tdrth: %x\n", reg.r.drth);
	}
	if (reg.r.mxdma != 0) {
		UserPrint("\tmxdma: %x\n", reg.r.mxdma);
	}
	if (reg.r.airl != 0) {
		UserPrint("\tairl: %x\n", reg.r.airl);
	}
	if (reg.r.alp != 0) {
		UserPrint("\talp: %x\n", reg.r.alp);
	}
	if (reg.r.rx_fd != 0) {
		UserPrint("\trx_fd: %x\n", reg.r.rx_fd);
	}
	if (reg.r.stripcrc != 0) {
		UserPrint("\tstripcrc: %x\n", reg.r.stripcrc);
	}
	if (reg.r.arp != 0) {
		UserPrint("\tarp: %x\n", reg.r.arp);
	}
	if (reg.r.aep != 0) {
		UserPrint("\taep: %x\n", reg.r.aep);
	}
}

static inline void print_pqcr ( union pqcr reg ) {	UserPrint("Debug pqcr - 0x%x\n", reg.data);}

static inline void print_wcsr ( union wcsr reg ) {	UserPrint("Debug wcsr - 0x%x\n", reg.data);}

static inline void print_pcr ( union pcr reg ) {	UserPrint("Debug pcr - 0x%x\n", reg.data);}

static inline void print_rfcr ( union rfcr reg ) {	UserPrint("Debug rfcr - 0x%x\n", reg.data);	if (reg.r.rfaddr != 0) {
		UserPrint("\trfaddr: %x\n", reg.r.rfaddr);
	}
	if (reg.r.aarp != 0) {
		UserPrint("\taarp: %x\n", reg.r.aarp);
	}
	if (reg.r.apm != 0) {
		UserPrint("\tapm: %x\n", reg.r.apm);
	}
	if (reg.r.aau != 0) {
		UserPrint("\taau: %x\n", reg.r.aau);
	}
	if (reg.r.aam != 0) {
		UserPrint("\taam: %x\n", reg.r.aam);
	}
	if (reg.r.aab != 0) {
		UserPrint("\taab: %x\n", reg.r.aab);
	}
	if (reg.r.rfen != 0) {
		UserPrint("\trfen: %x\n", reg.r.rfen);
	}
}

static inline void print_rfdr ( union rfdr reg ) {	UserPrint("Debug rfdr - 0x%x\n", reg.data);	if (reg.r.rfdata != 0) {
		UserPrint("\trfdata: %x\n", reg.r.rfdata);
	}
}

static inline void print_vrcr ( union vrcr reg ) {	UserPrint("Debug vrcr - 0x%x\n", reg.data);	if (reg.r.ipen != 0) {
		UserPrint("\tipen: %x\n", reg.r.ipen);
	}
	if (reg.r.ripe != 0) {
		UserPrint("\tripe: %x\n", reg.r.ripe);
	}
	if (reg.r.rtcpe != 0) {
		UserPrint("\trtcpe: %x\n", reg.r.rtcpe);
	}
	if (reg.r.rudpe != 0) {
		UserPrint("\trudpe: %x\n", reg.r.rudpe);
	}
}

static inline void print_vtcr ( union vtcr reg ) {	UserPrint("Debug vtcr - 0x%x\n", reg.data);	if (reg.r.gchk != 0) {
		UserPrint("\tgchk: %x\n", reg.r.gchk);
	}
	if (reg.r.ppchk != 0) {
		UserPrint("\tppchk: %x\n", reg.r.ppchk);
	}
}

static inline void print_ccsr ( union ccsr reg ) {	UserPrint("Debug ccsr - 0x%x\n", reg.data);	if (reg.r.clkrun_en != 0) {
		UserPrint("\tclkrun_en: %x\n", reg.r.clkrun_en);
	}
}

static inline void print_mibc ( union mibc reg ) {	UserPrint("Debug mibc - 0x%x\n", reg.data);	if (reg.r.wrn != 0) {
		UserPrint("\twrn: %x\n", reg.r.wrn);
	}
	if (reg.r.frz != 0) {
		UserPrint("\tfrz: %x\n", reg.r.frz);
	}
	if (reg.r.aclr != 0) {
		UserPrint("\taclr: %x\n", reg.r.aclr);
	}
	if (reg.r.mibs != 0) {
		UserPrint("\tmibs: %x\n", reg.r.mibs);
	}
}

static inline void print_mib_rxerroredpkts ( union mib_rxerroredpkts reg ) {	UserPrint("Debug mib_rxerroredpkts - 0x%x\n", reg.data);}

static inline void print_mib_rxfcserrors ( union mib_rxfcserrors reg ) {	UserPrint("Debug mib_rxfcserrors - 0x%x\n", reg.data);}

static inline void print_mib_rxmsdpkterrors ( union mib_rxmsdpkterrors reg ) {	UserPrint("Debug mib_rxmsdpkterrors - 0x%x\n", reg.data);}

static inline void print_mib_rxfaerrors ( union mib_rxfaerrors reg ) {	UserPrint("Debug mib_rxfaerrors - 0x%x\n", reg.data);}

static inline void print_mib_rxsymbolerrors ( union mib_rxsymbolerrors reg ) {	UserPrint("Debug mib_rxsymbolerrors - 0x%x\n", reg.data);}

static inline void print_mib_rxframetoolong ( union mib_rxframetoolong reg ) {	UserPrint("Debug mib_rxframetoolong - 0x%x\n", reg.data);}

static inline void print_mib_rxirlerrors ( union mib_rxirlerrors reg ) {	UserPrint("Debug mib_rxirlerrors - 0x%x\n", reg.data);}

static inline void print_mib_rxbadopcodes ( union mib_rxbadopcodes reg ) {	UserPrint("Debug mib_rxbadopcodes - 0x%x\n", reg.data);}

static inline void print_mib_rxpauseframes ( union mib_rxpauseframes reg ) {	UserPrint("Debug mib_rxpauseframes - 0x%x\n", reg.data);}

static inline void print_mib_txpauseframes ( union mib_txpauseframes reg ) {	UserPrint("Debug mib_txpauseframes - 0x%x\n", reg.data);}

static inline void print_mib_txsqeerrors ( union mib_txsqeerrors reg ) {	UserPrint("Debug mib_txsqeerrors - 0x%x\n", reg.data);}

#endif /* _DP83820_H_ */
