#ifndef _DP83820_DRIVER_H
#define _DP83820_DRIVER_H

/*
 * 32-bit PCI addressing 83820 packet descriptor 
 */
struct descriptor
{
  volatile uint32_t link;
  volatile uint32_t bufptr;
  volatile uint32_t cmdsts;
  volatile uint32_t extsts;
};

struct dp83820_desc
{
    struct descriptor d;
};

struct dp83820_channel
{
    struct dp83820_desc *desc;
    uint32_t desc_phys; /* assumes we always use 32 bit physical addressing */
    uintptr_t *desc_keys;

    uint32_t desc_cnt;
    uint32_t desc_curr;
    uint32_t desc_next_empty;
    uint32_t desc_inuse;
    
    mem_handle_t mem_handle;
    dmabuf_handle_t dma_handle;

    lock_t lock;

    uint8_t idle;
};


typedef struct ddp83820
{
	struct driver *classp;
	struct dp83820_channel rx;
	struct dp83820_channel tx;
	
	uint32_t cfg;		/* current driver CFG reg state */
	uint8_t mac_address[6];

	bus_space_t csr;
	bus_space_t pciconf;
	dma_handle_t dma;
	dma_handle_t tx_dma;

	void *cthis;	 /* needed? */
	struct bfr_drv *buf_man_handle;
	struct driver *buf_man;

	struct netstats *stats;
} ddp83820_t;

#define DESCSIZE (sizeof(struct dp83820_desc))

#define TX_NUMDESC  1536
#define RX_NUMDESC  512

//#define TX_NUMDESC  162
//#define RX_NUMDESC  160

#endif
