#ifndef _DP83820_TYPES_H_
#define _DP83820_TYPES_H_
struct cr_s{
	volatile uint32_t txe : 1;
	volatile uint32_t padding0 : 1;
	volatile uint32_t rxe : 1;
	volatile uint32_t padding1 : 5;
	volatile uint32_t rst : 1;
};

union cr{
	struct cr_s r;
	uint32_t data;
};

struct cfg_s{
	volatile uint32_t bem : 1;
	volatile uint32_t ext_125 : 1;
	volatile uint32_t brom_dis : 1;
	volatile uint32_t pesel : 1;
	volatile uint32_t exd : 1;
	volatile uint32_t pow : 1;
	volatile uint32_t sb : 1;
	volatile uint32_t reqalg : 1;
	volatile uint32_t extsts_en : 1;
	volatile uint32_t phy_dis : 1;
	volatile uint32_t phy_rst : 1;
	volatile uint32_t m64addr : 1;
	volatile uint32_t data64_en : 1;
	volatile uint32_t pci64_det : 1;
	volatile uint32_t t64addr : 1;
	volatile uint32_t mwi_dis : 1;
	volatile uint32_t mrm_dis : 1;
	volatile uint32_t tmrtest : 1;
	volatile uint32_t pint_dupsts : 1;
	volatile uint32_t pint_lnksts : 1;
	volatile uint32_t pint_spdsts : 1;
	volatile uint32_t auto_1000 : 1;
	volatile uint32_t mode_1000 : 1;
	volatile uint32_t auto_dup : 1;
	volatile uint32_t tbi_en : 1;
	volatile uint32_t padding0 : 3;
	volatile uint32_t dupsts : 1;
	volatile uint32_t spdsts : 2;
	volatile uint32_t lnksts : 1;
};

union cfg{
	struct cfg_s r;
	uint32_t data;
};

struct ptscr_s{
	volatile uint32_t eebist_fail : 1;
	volatile uint32_t eebist_en : 1;
	volatile uint32_t eeload : 1;
};

union ptscr{
	struct ptscr_s r;
	uint32_t data;
};

struct isr_s{
	volatile uint32_t rxok : 1;
	volatile uint32_t rxdesc : 1;
	volatile uint32_t rxerr : 1;
	volatile uint32_t rxearly : 1;
	volatile uint32_t rxidle : 1;
	volatile uint32_t rxorn : 1;
	volatile uint32_t txok : 1;
	volatile uint32_t txdesc : 1;
	volatile uint32_t txerr : 1;
	volatile uint32_t txidle : 1;
	volatile uint32_t txurn : 1;
	volatile uint32_t mib : 1;
	volatile uint32_t swi : 1;
	volatile uint32_t pme : 1;
	volatile uint32_t phy : 1;
	volatile uint32_t hibint : 1;
	volatile uint32_t rxsovr : 1;
	volatile uint32_t rtabt : 1;
	volatile uint32_t rmabt : 1;
	volatile uint32_t sserr : 1;
	volatile uint32_t dperr : 1;
	volatile uint32_t rxrcmp : 1;
	volatile uint32_t txrcmp : 1;
};

union isr{
	struct isr_s r;
	uint32_t data;
};

struct imr_s{
	volatile uint32_t rxok : 1;
	volatile uint32_t rxdesc : 1;
	volatile uint32_t rxerr : 1;
	volatile uint32_t rxearly : 1;
	volatile uint32_t rxidle : 1;
	volatile uint32_t rxorn : 1;
	volatile uint32_t txok : 1;
	volatile uint32_t txdesc : 1;
	volatile uint32_t txerr : 1;
	volatile uint32_t txidle : 1;
	volatile uint32_t txurn : 1;
	volatile uint32_t mib : 1;
	volatile uint32_t swi : 1;
	volatile uint32_t pme : 1;
	volatile uint32_t phy : 1;
	volatile uint32_t hibint : 1;
	volatile uint32_t rxsovr : 1;
	volatile uint32_t rtabt : 1;
	volatile uint32_t rmabt : 1;
	volatile uint32_t sserr : 1;
	volatile uint32_t dperr : 1;
	volatile uint32_t rxrcmp : 1;
	volatile uint32_t txrcmp : 1;
};

union imr{
	struct imr_s r;
	uint32_t data;
};

struct ier_s{
};

union ier{
	struct ier_s r;
	uint32_t data;
};

struct ihr_s{
};

union ihr{
	struct ihr_s r;
	uint32_t data;
};

struct txdp_s{
};

union txdp{
	struct txdp_s r;
	uint32_t data;
};

struct txdp_hi_s{
};

union txdp_hi{
	struct txdp_hi_s r;
	uint32_t data;
};

struct txcfg_s{
	volatile uint32_t drth : 8;
	volatile uint32_t flth : 8;
	volatile uint32_t padding0 : 4;
	volatile uint32_t mxdma : 3;
	volatile uint32_t padding1 : 5;
	volatile uint32_t atp : 1;
	volatile uint32_t padding2 : 1;
	volatile uint32_t hbi : 1;
	volatile uint32_t csi : 1;
};

union txcfg{
	struct txcfg_s r;
	uint32_t data;
};

struct rxdp_s{
};

union rxdp{
	struct rxdp_s r;
	uint32_t data;
};

struct rxdp_hi_s{
};

union rxdp_hi{
	struct rxdp_hi_s r;
	uint32_t data;
};

struct rxcfg_s{
	volatile uint32_t padding0 : 1;
	volatile uint32_t drth : 5;
	volatile uint32_t padding1 : 14;
	volatile uint32_t mxdma : 3;
	volatile uint32_t padding2 : 3;
	volatile uint32_t airl : 1;
	volatile uint32_t alp : 1;
	volatile uint32_t rx_fd : 1;
	volatile uint32_t stripcrc : 1;
	volatile uint32_t arp : 1;
	volatile uint32_t aep : 1;
};

union rxcfg{
	struct rxcfg_s r;
	uint32_t data;
};

struct pqcr_s{
};

union pqcr{
	struct pqcr_s r;
	uint32_t data;
};

struct wcsr_s{
};

union wcsr{
	struct wcsr_s r;
	uint32_t data;
};

struct pcr_s{
};

union pcr{
	struct pcr_s r;
	uint32_t data;
};

struct rfcr_s{
	volatile uint32_t rfaddr : 10;
	volatile uint32_t padding0 : 12;
	volatile uint32_t aarp : 1;
	volatile uint32_t padding1 : 4;
	volatile uint32_t apm : 1;
	volatile uint32_t aau : 1;
	volatile uint32_t aam : 1;
	volatile uint32_t aab : 1;
	volatile uint32_t rfen : 1;
};

union rfcr{
	struct rfcr_s r;
	uint32_t data;
};

struct rfdr_s{
	volatile uint32_t rfdata : 16;
};

union rfdr{
	struct rfdr_s r;
	uint32_t data;
};

struct vrcr_s{
	volatile uint32_t padding0 : 4;
	volatile uint32_t ipen : 1;
	volatile uint32_t ripe : 1;
	volatile uint32_t rtcpe : 1;
	volatile uint32_t rudpe : 1;
};

union vrcr{
	struct vrcr_s r;
	uint32_t data;
};

struct vtcr_s{
	volatile uint32_t padding0 : 2;
	volatile uint32_t gchk : 1;
	volatile uint32_t ppchk : 1;
};

union vtcr{
	struct vtcr_s r;
	uint32_t data;
};

struct ccsr_s{
	volatile uint32_t clkrun_en : 1;
};

union ccsr{
	struct ccsr_s r;
	uint32_t data;
};

struct mibc_s{
	volatile uint32_t wrn : 1;
	volatile uint32_t frz : 1;
	volatile uint32_t aclr : 1;
	volatile uint32_t mibs : 1;
};

union mibc{
	struct mibc_s r;
	uint32_t data;
};

struct mib_rxerroredpkts_s{
};

union mib_rxerroredpkts{
	struct mib_rxerroredpkts_s r;
	uint16_t data;
};

struct mib_rxfcserrors_s{
};

union mib_rxfcserrors{
	struct mib_rxfcserrors_s r;
	uint16_t data;
};

struct mib_rxmsdpkterrors_s{
};

union mib_rxmsdpkterrors{
	struct mib_rxmsdpkterrors_s r;
	uint16_t data;
};

struct mib_rxfaerrors_s{
};

union mib_rxfaerrors{
	struct mib_rxfaerrors_s r;
	uint16_t data;
};

struct mib_rxsymbolerrors_s{
};

union mib_rxsymbolerrors{
	struct mib_rxsymbolerrors_s r;
	uint16_t data;
};

struct mib_rxframetoolong_s{
};

union mib_rxframetoolong{
	struct mib_rxframetoolong_s r;
	uint16_t data;
};

struct mib_rxirlerrors_s{
};

union mib_rxirlerrors{
	struct mib_rxirlerrors_s r;
	uint16_t data;
};

struct mib_rxbadopcodes_s{
};

union mib_rxbadopcodes{
	struct mib_rxbadopcodes_s r;
	uint16_t data;
};

struct mib_rxpauseframes_s{
};

union mib_rxpauseframes{
	struct mib_rxpauseframes_s r;
	uint16_t data;
};

struct mib_txpauseframes_s{
};

union mib_txpauseframes{
	struct mib_txpauseframes_s r;
	uint16_t data;
};

struct mib_txsqeerrors_s{
};

union mib_txsqeerrors{
	struct mib_txsqeerrors_s r;
	uint8_t data;
};

#endif /* _DP83820_TYPES_H_ */
