#ifndef _KENGE_OS_H_
#define _KENGE_OS_H_

#include <io/io.h>

#include <stdlib.h>
#include "lock.h"
#include <assert.h>
#include "udelay.h"
#include <stdbool.h>

#include "e1000_hw.h"

#define ASSERT(x) assert (x)

#define usec_delay(x) udelay(x)
#define msec_delay(x) mdelay(x)

#define MSGOUT(S, A, B)     UserPrint(S "\n", A, B)
#define DEBUGFUNC(F)        UserPrint(F)

#if 1
	#define DEBUGOUT(S)         UserPrint(S "\n")
	#define DEBUGOUT1(S,A)      UserPrint(S "\n",A)
	#define DEBUGOUT2(S,A,B)    UserPrint(S "\n",A,B)
	#define DEBUGOUT3(S,A,B,C)  UserPrint(S "\n",A,B,C)
	#define DEBUGOUT7(S,A,B,C,D,E,F,G)  UserPrint(S "\n",A,B,C,D,E,F,G)
#else
	#define DEBUGOUT(S)
	#define DEBUGOUT1(S,A)
	#define DEBUGOUT2(S,A,B)
	#define DEBUGOUT3(S,A,B,C)
	#define DEBUGOUT7(S,A,B,C,D,E,F,G)
#endif

#define FALSE               0
#define TRUE                1
#define CMD_MEM_WRT_INVALIDATE          0x0010  /* BIT_4 */
#define PCI_COMMAND_REGISTER            PCIR_COMMAND

/* XXXX danielp: em_osdep needs to be changed to Kenge specific. */
struct em_osdep
{
//	bus_space_tag_t    mem_bus_space_tag;
//	bus_space_handle_t mem_bus_space_handle;
//	struct device     *dev;
	int dummy;
};

#define E1000_WRITE_FLUSH(a) E1000_READ_REG(a, STATUS)

/* Read from an absolute offset in the adapter's memory space */
#define E1000_READ_OFFSET(a, offset) io_read_32((a)->mhandle, offset)

/* Write to an absolute offset in the adapter's memory space */
#define E1000_WRITE_OFFSET(a, offset, value) io_write_32((a)->mhandle, (offset), value)

/* Convert a register name to its offset in the adapter's memory space */
#define E1000_REG_OFFSET(a, reg) \
	((a)->mac_type >= e1000_82543 ? E1000_##reg : E1000_82542_##reg)	
#define E1000_READ_REG(a, reg) \
	io_read_32((a)->mhandle, E1000_REG_OFFSET(a, reg))
#define E1000_WRITE_REG(a, reg, value) \
	io_write_32((a)->mhandle, E1000_REG_OFFSET(a, reg), value) 
#define E1000_READ_REG_BYTE(a, reg) \
	io_read_8((a)->pciconf, reg)
#define	E1000_WRITE_REG_BYTE(a, reg, value) \
	io_write_8((a)->pciconf, reg, value)
#define E1000_READ_REG_WORD(a, reg) \
	io_read_16((a)->pciconf, reg)
#define	E1000_WRITE_REG_WORD(a, reg, value) \
	io_write_16((a)->pciconf, reg, value)
#define E1000_READ_REG_ARRAY(a, reg, index) \
	io_read_32((a)->mhandle, E1000_REG_OFFSET(a, reg) + ((index)<<2))
#define E1000_WRITE_REG_ARRAY(a, reg, index, value) \
	io_write_32((a)->mhandle, (E1000_REG_OFFSET(a, reg) + ((index)<<2)), value) 
#define E1000_IO_READ(a, port) io_read_32((a)->iohandle, port)
#define E1000_IO_WRITE_OFFSET(a, port, offset) \
        io_write_32((a)->iohandle, port, offset)
#define	E1000_IO_WRITE_VALUE(a, port, value) \
        io_write_32((a)->iohandle, port, value)	
#endif  /* _KENGE_OS_H_ */

