#include <stdint.h>
#include <atomic.h>
#include <driver_env_glue.h>
#include <io/io.h>

typedef uint32_t u32;
typedef atomic_t MM_ATOMIC_T;
#define MM_ATOMIC_SET(p,i)	atomic_set(p,i)
#define MM_ATOMIC_READ(p)	atomic_read(p)
#define MM_ATOMIC_INC(p)	atomic_inc(p)
#define MM_ATOMIC_DEC(p)	atomic_dec(p)
#define MM_ATOMIC_ADD(p,i)	atomic_add(i,p)
#define MM_ATOMIC_SUB(p,i)	atomic_sub(i,p)
#define MM_MEMREADL(p)		readl(p)
#define MM_MEMWRITEL(p,v)	writel(p,v)
#define MM_MB()		mb()
#define MM_RMB()	rmb()
#define MM_WMB()	wmb()
#define MM_MMIOWB()	/* nothing */
#define MM_UINT_PTR(p)	((uintptr_t)(p))
#define MM_Wait(usec)	udelay(usec)

#ifndef __ia64__
# error Fix byteswap macros for this arch?
#endif
#define MM_SWAP_LE32(x) (x)
#define MM_SWAP_BE32(x) ((((x) & 0xff000000) >> 24) | (((x) & 0x00ff0000) >>  8) |               \
		            (((x) & 0x0000ff00) <<  8) | (((x) & 0x000000ff) << 24))

#define MM_SetAddr(paddr, addr) \
	do { paddr->High = addr >> 32; paddr->Low = addr & 0xffffffff; } while (0);

extern int MM_Packet_Desc_Size;
#define MM_PACKET_DESC_SIZE MM_Packet_Desc_Size

/* FIXME for SMP? */
#define MM_ACQUIRE_UNDI_LOCK(dev) /* nothing */
#define MM_RELEASE_UNDI_LOCK(dev) /* nothing */
#define MM_ACQUIRE_PHY_LOCK_IN_IRQ(dev) /* nothing */
#define MM_RELEASE_PHY_LOCK_IN_IRQ(dev) /* nothing */

#define STATIC		static
#define printk		printf
#define KERN_WARNING	"tigon3: "
#define KERN_ALERT	"tigon3: "

/* N.B. tigon3.c doesn't compile if these are disabled */
#define INCLUDE_TBI_SUPPORT 1
#define T3_JUMBO_RCV_RCB_ENTRY_COUNT 256

#include "lm.h"
#include "tigon3.h"

void MM_MapRxDma(PLM_DEVICE_BLOCK pDevice, struct _LM_PACKET *pPacket, T3_64BIT_HOST_ADDR *paddr);
void MM_MapTxDma(PLM_DEVICE_BLOCK pDevice, struct _LM_PACKET *pPacket, T3_64BIT_HOST_ADDR *paddr, LM_UINT32 *len, int frag);
