#ifndef _UART16550_TYPES_H_
#define _UART16550_TYPES_H_
struct data_s{
};

union data{
	struct data_s r;
	uint8_t data;
};

struct ier_s{
	volatile uint8_t rx_int : 1;
	volatile uint8_t tx_int : 1;
	volatile uint8_t line_status_int : 1;
	volatile uint8_t modem_status_int : 1;
};

union ier{
	struct ier_s r;
	uint8_t data;
};

struct fcr_s{
	volatile uint8_t fifo_enable : 1;
	volatile uint8_t rx_fifo_clear : 1;
	volatile uint8_t tx_fifo_clear : 1;
	volatile uint8_t padding0 : 3;
	volatile uint8_t trigger_level : 2;
};

union fcr{
	struct fcr_s r;
	uint8_t data;
};

struct iir_s{
	volatile uint8_t npending : 1;
	volatile uint8_t source : 2;
	volatile uint8_t timeout : 1;
	volatile uint8_t padding0 : 2;
	volatile uint8_t trigger_level : 2;
};

union iir{
	struct iir_s r;
	uint8_t data;
};

struct lcr_s{
	volatile uint8_t data_bits : 2;
	volatile uint8_t stop_bits : 1;
	volatile uint8_t parity_enable : 1;
	volatile uint8_t even_parity : 1;
	volatile uint8_t stick_parity : 1;
	volatile uint8_t brk : 1;
	volatile uint8_t dlab : 1;
};

union lcr{
	struct lcr_s r;
	uint8_t data;
};

struct mcr_s{
	volatile uint8_t ndtr : 1;
	volatile uint8_t nrts : 1;
	volatile uint8_t out1 : 1;
	volatile uint8_t out2 : 1;
	volatile uint8_t test : 1;
};

union mcr{
	struct mcr_s r;
	uint8_t data;
};

struct lsr_s{
	volatile uint8_t rx_avail : 1;
	volatile uint8_t overrun : 1;
	volatile uint8_t parity_err : 1;
	volatile uint8_t framing_err : 1;
	volatile uint8_t brk : 1;
	volatile uint8_t tx_empty : 1;
	volatile uint8_t tx_done : 1;
	volatile uint8_t err_in_fifo : 1;
};

union lsr{
	struct lsr_s r;
	uint8_t data;
};

struct msr_s{
	volatile uint8_t dcts : 1;
	volatile uint8_t ddsr : 1;
	volatile uint8_t dri : 1;
	volatile uint8_t ddcd : 1;
	volatile uint8_t ncts : 1;
	volatile uint8_t ndsr : 1;
	volatile uint8_t nri : 1;
	volatile uint8_t ndcd : 1;
};

union msr{
	struct msr_s r;
	uint8_t data;
};

struct dll_s{
};

union dll{
	struct dll_s r;
	uint8_t data;
};

struct dlh_s{
};

union dlh{
	struct dlh_s r;
	uint8_t data;
};

#endif /* _UART16550_TYPES_H_ */
