extern struct ia64_boot_param {
	uint64_t command_line;		/* physical address of command line arguments */
	uint64_t efi_systab;		/* physical address of EFI system table */
	uint64_t efi_memmap;		/* physical address of EFI memory map */
	uint64_t efi_memmap_size;		/* size of EFI memory map */
	uint64_t efi_memdesc_size;		/* size of an EFI memory map descriptor */
	uint32_t efi_memdesc_version;	/* memory descriptor version */
	struct {
		uint16_t num_cols;	/* number of columns on console output device */
		uint16_t num_rows;	/* number of rows on console output device */
		uint16_t orig_x;	/* cursor's x position */
		uint16_t orig_y;	/* cursor's y position */
	} console_info;
	uint64_t fpswa;		/* physical address of the fpswa interface */
	uint64_t initrd_start;
	uint64_t initrd_size;
} *ia64_boot_param;

