#ifndef _DRIVER_ENV_GLUE_H
#define _DRIVER_ENV_GLUE_H

#include <stddef.h>
#include <stdint.h>
#include <string.h>
#include "types.h"
#include "proto.h"

enum { IORESOURCE_MEM, IORESOURCE_IO, IORESOURCE_PCICONF };

typedef unsigned long dma_addr_t;
typedef unsigned long mem_handle_t;
typedef void * dma_handle_t;
#if 0
typedef int bool;
#define false 0
#define true 1
#endif
#define UserPrint printf
#define PAGESIZE 4096
#define RX_BUF_SIZE (PAGESIZE+64)
#if 0
#define mb() asm volatile ("mf" ::: "memory")
#endif
#define udelay(usec) { int i; for (i = 0; i < usec * 1024; i++); }

typedef struct {
	mem_handle_t vaddr;
	dma_addr_t addr;
	size_t size;
} dmabuf_handle_t;

#define GLUE_DMABUF_NENTS(x)		1
#define GLUE_DMABUF_ENT_LEN(x,i)	x.size
#define GLUE_DMABUF_ENT_DMAADDR(x,i)	x.addr
#define GLUE_DMABUF_ENT_VADDR(x,i)	x.vaddr

typedef struct {
	uintptr_t address;
	int type;
} bus_space_t;

typedef struct request *callback_data_t;
#define null_callback_data NULL
/* extern callback_data_t null_callback_data; */

mem_handle_t new_mem_handle(void *addr, size_t sz);
void free_mem_handle(mem_handle_t handle);
mem_handle_t handle_increment(mem_handle_t *handle, size_t sz);

#if 0
#define assert(cond) do {\
        if (!(cond)) {\
		printf("assertion failed at %s:%d\n",\
			__FILE__, __LINE__);\
	}\
    } while (0)
#endif

extern int pagesize;

#define new_mem_handle(addr,size)	(mem_handle_t)addr
#define get_addr(handle)		(void *)handle
#define free_mem_handle(handle)
#define handle_increment(handlep,size)	(*handlep += size)

#endif
