#ifndef _TYPES_H
#define _TYPES_H

#include <stdint.h>

typedef unsigned int node_t;
typedef unsigned int mpfn_t;
typedef unsigned int boolean;
typedef uint16_t copyset_t;
typedef uint32_t pfn_t;

typedef enum {
	ACCESS_DATA,
	ACCESS_RSE,
	ACCESS_EXECUTE
} access_type_t;

/* write buffer entry */
struct store
{
	uint64_t mpa;
	uint64_t value;
	uint16_t wu_version;
	uint8_t size;
};

/* SCSI scatter gather entry */
/* note that this is the same as a simscsi SGE for convenience */
struct scsi_sge
{
	unsigned long addr;
	unsigned len;
	mpfn_t mpfn;
};

/* SCSI scatter gather list */
struct scsi_sglist
{
	unsigned int nsge;
	struct scsi_sge sge[49];
};

/* forward declarations of certain opaque structures */
struct ia64_boot_param;
struct pal_ret;
struct driver;
struct request;

#endif
