/*
 @LICENSE@
*/

/*-
 * Copyright (c) 2003 Cristan Szmajda.  All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution. 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by Cristan Szmajda. 
 * 4. The name Cristan Szmajda may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY CRISTAN SZMAJDA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL CRISTAN SZMAJDA BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 * 
 * $Id: string.h,v 1.2 2004/01/27 22:23:56 benjl Exp $
 */

#ifndef	_STRING_H_
#define	_STRING_H_

#include <stddef.h>

void           *memcpy(void *, const void *, size_t);
void           *memmove(void *, const void *, size_t);
void           *memset(void *, int, size_t);
int             memcmp(const void *, const void *, size_t);
void           *memchr(const void *, int, size_t);
size_t          strlen(const char *);
char           *strcpy(char *, const char *);
char           *strncpy(char *, const char *, size_t);
size_t          strlcpy(char *, const char *, size_t);
char           *strcat(char *, const char *);
size_t          strlcat(char *, const char *, size_t);
char           *strncat(char *, const char *, size_t);
int             strcmp(const char *, const char *);
int             strncmp(const char *, const char *, size_t);
char           *strchr(const char *, int);
char           *strrchr(const char *, int);
size_t          strspn(const char *, const char *);
size_t          strcspn(const char *, const char *);
char           *strpbrk(const char *s, const char *charset);
char           *strstr(const char *, const char *);
char           *strtok(char *s, const char *delim);
char           *strtok_r(char *s, const char *delim, char **endp);

#endif				/* _STRING_H_ */
