/*
 @LICENSE@
*/

/*-
 * Copyright (c) 2003 Cristan Szmajda.  All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution. 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by Cristan Szmajda. 
 * 4. The name Cristan Szmajda may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY CRISTAN SZMAJDA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL CRISTAN SZMAJDA BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 * 
 * $Id: memchr.c,v 1.2 2004/01/27 22:23:56 benjl Exp $
 */

#include <string.h>

/*
 * return pointer to first occurrence of c in s 
 */
#if __ia64__
#include <stdint.h>
void           *
memchr(const void *s, int c)
{
	uint64_t        cccccccc,
	                pppppppp,
	                i;
	const char     *p;

	/*
	 * search 1 byte at a time 
	 */
	for (p = (const char *) s; ((uintptr_t) p & 0x7) != 0; p++)
		if (*p == c)
			return (void *) p;
	/*
	 * search 8 bytes at a time 
	 */
      asm("mux1 %0 = %1, @brcst": "=r"(cccccccc):"r"(c));
	do {
		pppppppp = *(const uint64_t *) p;
	      asm("czx1.r %0=%1": "=r"(i):"r"(pppppppp ^
		    cccccccc));
		p += i;
	} while (i == 8);
	return (void *) p;
}
#else
void           *
memchr(const void *s, int c, size_t n)
{
	const char     *p;

	for (p = (const char *) s; *p != c; s++);
	return (void *) p;
}
#endif
