/*
 @LICENSE@
*/

/*-
 * Copyright (c) 2003 Cristan Szmajda.  All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution. 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by Cristan Szmajda. 
 * 4. The name Cristan Szmajda may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY CRISTAN SZMAJDA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL CRISTAN SZMAJDA BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 * 
 * $Id: strlen.c,v 1.2 2004/01/27 22:23:57 benjl Exp $
 */

#include <string.h>

/*
 * measure length of a string, not including the '\0' 
 */
#if __ia64__
#include <stdint.h>
size_t
strlen(const char *s)
{
	uint64_t        n,
	                pppppppp;
	const char     *p;

	/*
	 * count 1 character at a time 
	 */
	for (p = s; ((uintptr_t) p & 0x7) != 0; p++)
		if (*p == '\0')
			return p - s;
	/*
	 * count 8 characters at a time 
	 */
	for (;;) {
		pppppppp = *(const uint64_t *) p;
	      asm("czx1.r %0 = %1": "=r"(n):"r"(pppppppp));
		p += n;
		if (n != 8)
			return p - s;
	}
}
#else
size_t
strlen(const char *s)
{
	const char     *p;

	for (p = s; *p != '\0'; p++);
	return p - s;
}
#endif
