/*
 @LICENSE@
*/

#ifndef _CHIPSET_H_
#define _CHIPSET_H_

#include <driver_interface.h>
#include <types.h>
#include <stdint.h>

struct chipset_ops {
	void            (*_init) (void *pvt /*, host_handle_t host*/);
	void            (*_conf_write_8) (void *pvt, int bus, int device,
					  int function, int register_num,
					  uint8_t value);
	void            (*_conf_write_16) (void *pvt, int bus, int device,
					   int function, int register_num,
					   uint16_t value);
	void            (*_conf_write_32) (void *pvt, int bus, int device,
					   int function, int register_num,
					   uint32_t value);
	     
	     
	     
	     
	     
	     
	    uint8_t(*_conf_read_8) (void *pvt, int bus,
				    int device, int function,
				    int register_num);
	     
	     
	     
	     
	     
	     
	    uint16_t(*_conf_read_16) (void *pvt, int bus,
				      int device, int function,
				      int register_num);
	     
	     
	     
	     
	     
	     
	    uint32_t(*_conf_read_32) (void *pvt, int bus,
				      int device, int function,
				      int register_num);
	     
	     
	     
	     
	     
	     
	    bus_space_t(*_pci_iospace_map) (void *pvt,
					    bus_addr_t bus,
					    uintptr_t size, int flags);
	int             (*_pci_register_interrupt) (void *pvt, int irq,
						    exec_handle_t handler);
};

#define init(inst, args...) \
        inst->ops->_init(inst->pvt, ##args)
#define conf_write_8(inst, args...) \
        inst->ops->_conf_write_8(inst->pvt, ##args)
#define conf_write_16(inst, args...) \
        inst->ops->_conf_write_16(inst->pvt, ##args)
#define conf_write_32(inst, args...) \
        inst->ops->_conf_write_32(inst->pvt, ##args)
#define conf_read_8(inst, args...) \
        inst->ops->_conf_read_8(inst->pvt, ##args)
#define conf_read_16(inst, args...) \
        inst->ops->_conf_read_16(inst->pvt, ##args)
#define conf_read_32(inst, args...) \
        inst->ops->_conf_read_32(inst->pvt, ##args)
#define pci_iospace_map(inst, args...) \
        inst->ops->_pci_iospace_map(inst->pvt, ##args)
#define pci_register_interrupt(inst, args...) \
        inst->ops->_pci_register_interrupt(inst->pvt, ##args)

struct chipset {
	struct chipset_ops *ops;
	void           *pvt;
};

#endif				/* _CHIPSET_H_ */
