#ifndef _MUNGI_ALPHA_PCI_CONF_H
#define _MUNGI_ALPHA_PCI_CONF_H
#include <ipci_conf_io.idl.h>
#include <types.h>
#include <paxlib.h>
#include <bus.h>

static inline uint8_t
pci_conf_read_8(bus_space_t bus, uint64_t addr)
{
    environment_t ev;
    return ipci_conf_read_8((IPCI_Conf_t*) bus.address.address, addr, &ev);
}

static inline uint16_t
pci_conf_read_16(bus_space_t bus, uint64_t addr)
{
    environment_t ev;
    return ipci_conf_read_16((IPCI_Conf_t*) bus.address.address, addr, &ev);
}

static inline uint32_t
pci_conf_read_32(bus_space_t bus, uint64_t addr)
{
    environment_t ev;
    return ipci_conf_read_32((IPCI_Conf_t*) bus.address.address, addr, &ev);
}

static inline void
pci_conf_write_8(bus_space_t bus, uint64_t addr, uint8_t val)
{
    environment_t ev;
    return ipci_conf_write_8((IPCI_Conf_t*) bus.address.address, addr, val, &ev);
}

static inline void
pci_conf_write_16(bus_space_t bus, uint64_t addr, uint16_t val)
{
    environment_t ev;
    return ipci_conf_write_16((IPCI_Conf_t*) bus.address.address, addr, val, &ev);
}

static inline void
pci_conf_write_32(bus_space_t bus, uint64_t addr, uint32_t val)
{
    environment_t ev;
    return ipci_conf_write_32((IPCI_Conf_t*) bus.address.address, addr, val, &ev);
}
#endif
