#ifndef _DRIVER_ENV_GLUE_H
#define _DRIVER_ENV_GLUE_H


#include <linux/pci.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <linux/mm.h>
#include <asm/page.h>
#include <linux/smp_lock.h>

#include <stdbool.h>

#include <stdint.h>
#include "pci_dma.h"

#define PAGESIZE PAGE_SIZE

extern int pagesize;

typedef struct request *callback_data_t;
extern callback_data_t null_callback_data;



/*
 * Kind of bus space
 */
enum bus_access {
	IOPORT,
	PCI_CONFIG,
	PCI_MEM,
};

struct pci_dev;

/*
 * Describe access to part of a device's bus space
 * -- currently IO space and PCI Config space; could add MMIO space later.
 */

typedef struct {
	bool is_pciconfig;
	union {
		struct {
			unsigned long start;
			unsigned long end;
			unsigned long flags;
		} normal;
		struct {
			struct pci_dev* pcidev;
		} pciconfig;
	} u;
} bus_space_t;



#define UserPrint(fmt, args...) printk(KERN_ERR fmt, ## args)


#endif
