/*
 *        Project:  
 *        Created:  13/03/2003 18:42:20 by Simon Winwood (sjw)
 *  Last Modified:  20/03/2003 17:30:59 by Simon Winwood (sjw)
 *   Version info:  $Revision: 1.1 $ 
 *    Description:
 *
 *       Comments:
 *
 * $Log: lock.h,v $
 * Revision 1.1  2004/03/03 04:12:29  peterc
 * First cut at glue code for in-kernel.  Based loosely on the old
 * drivers tree.
 *
 * Revision 1.3  2003/03/20 22:39:56  sjw
 * Bugfixes; the driver is now reasonably complete, with thread etc.
 *
 * Revision 1.2  2003/03/20 06:28:46  sjw
 * Added lock implementation.
 *
 * Revision 1.1  2003/03/16 22:12:58  sjw
 * Moved a lot of the mungi-isms out of the code, or have started to.
 * Still needs a bit of work.
 *
 */

#ifndef LOCK_H
#define LOCK_H

#include <linux/spinlock.h>

typedef struct {
    spinlock_t lock;
    unsigned long flags;
} lock_t;

static inline void lock_init(lock_t *lock) 
{
    spin_lock_init(&lock->lock);
}

static inline void lock_lock(lock_t *lock) 
{
    unsigned long flags;
    spin_lock_irqsave(&lock->lock, flags);
    lock->flags = flags;
}

static inline void lock_unlock(lock_t *lock) 
{
    spin_unlock_irqrestore(&lock->lock, lock->flags);
}
#endif /* LOCK_H */
