/*
 * Wrap kernel memory allocation functions
 */
#ifndef MALLOC_H
#define MALLOC_H

#include <linux/types.h>
#include <linux/slab.h>
#include <linux/gfp.h>
#include <asm/hardirq.h> /* in_atomic() */
#undef TIME_WAIT

static inline void *malloc(size_t size)
{
	return kmalloc(size, in_atomic() ? GFP_ATOMIC : GFP_KERNEL);
}

static inline void free(void *ptr)
{
	kfree(ptr);
}


#endif /* MALLOC_H */

