#include <sys/times.h>
#include <pthread.h>

/*--------------------------------------------------------------------------
Source and test case at http://www.kegel.com/lt.tar.gz

Monitor the CPU usage of a bunch of threads in the same process.
This is a simulation of the system call times()
providing traditional semantics under LinuxThreads.
On e.g. Solaris, you don't need this; you just call the standard times().
--------------------------------------------------------------------------*/

void LinuxTimes_Init(void);

/**
 *   New threads call this to add themselves to the group.
 *   Threadsafe.
 *   @return 0 on success, Unix error code on failure
 */
int monitorme(void);

/**
 * Calculate user and system time accumulated by all threads in group.
 *
 * Return result in tms_utime and tms_stime fields of given struct tms.
 * Similar to 'man 2 times' on Solaris (where all CPU time of all threads
 * is counted as CPU time towards the process).
 *
 * @return 0 on success, Unix error code on failure
 */
int LinuxTimes(struct tms *buf);

