/************************************************************************
 * Atomic and barrier operations for a variety of architectures.
 * Mostly stolen from Linux 2.5.X
 *
 * @(#)$Id: atomic.h,v 1.2 2004/09/10 06:20:34 ritashen Exp $
 *
 */

#ifndef ATOMIC_H_
#define ATOMIC_H_

#ifdef __i386__
# include "atomic-ia32.h"
#elif defined(__ia64__)
# include "atomic-ia64.h"
#elif defined(__alpha__)
# include "atomic-alpha.h"
#elif defined(__mips__)
# include "atomic_mips.h"  
#else
# error "No atomic definitions for your architecture yet!"
#endif

static inline
void atomic_init(atomic_t *ap, int value)
{
	atomic_set(ap, value);
}
#endif
