#ifndef _DRIVER_ENV_GLUE_H
#define _DRIVER_ENV_GLUE_H

#include <bus.h>
#include <mungi.idlh.h>
#include <mlib.h>
#include <paxlib.h>

typedef struct {
	cicap_t notify;
	void *cthis;
} callback_data_t;


#include <idma_io.idl.h>
#include <ipci_conf_io.idl.h>

#define DMA_TO_DEVICE 1
#define DMA_FROM_DEVICE 2
#define DMA_BIDIRECTIONAL 3

#define GLUE_DMABUF_NENTS(x) (x->c)
#define GLUE_DMABUF_ENT_LEN(x, i) (x->v[i].length)
#define GLUE_DMABUF_ENT_DMAADDR(x, i) (x->v[i].addr)

#define GLUE_DMABUF_IS_NULL(x) (x == NULL)

struct sg_area {
	
};

struct dma_handle {
	IDMA_t *dma;
	cap_seq *unpin;
	pin_seq *pin;
	void *sg_area;
	void *max_sg;
	int numpinned;
};

typedef struct dma_handle * dma_handle_t;
typedef unsigned long dma_addr_t;

typedef struct {
	void            (*function) (void *);
	void           *data;
} exec_handle_t;

#define EXECUTE_HANDLE(x) (x.function(x.data))

#define NULL_EXEC_HANDLE { NULL, NULL }

/*
 * Kind of bus space
 */
enum bus_access {
	IOPORT,
	PCI_CONFIG,
	PCI_MEM,
};


extern callback_data_t null_callback_data;

/*
 * A DMA scatter-gather  list in addresses as seen from the device.
 */
struct dmabuf_handle  {
	cap_t handle;
	size_t size;
	//struct dmabuf_handle *prev;
	void *client_ref;
	unsigned int c;
	sg_t v[];
}; 

typedef struct dmabuf_handle * dmabuf_handle_t;

extern dmabuf_handle_t null_dmabuf;

#define UserPrint printf

static inline void *
get_addr(mem_handle_t handle) 
{
	return (void*)handle.address;
}

static inline mem_handle_t 
new_mem_handle(void *addr, size_t sz) 
{
	mem_handle_t handle;
	handle.address = addr;
	handle.passwd = 0;
	return handle;
}

static inline void
free_mem_handle(mem_handle_t *h)
{
	(void)h;
}

static inline mem_handle_t
handle_increment(mem_handle_t *handle, size_t sz)
{
	handle->address += sz;
	return *handle;
}

/* Evil evil evil hack */
#define printf UserPrint 

//extern int pagesize;
#define pagesize PAGESIZE

/* Mungi only stuff */
dma_handle_t get_dma_handle(cicap_t dma_cicap);
bus_space_t get_pciconf_bus(cicap_t pci_conf, cap_t pb, int size);

#endif
