#include "error.h"
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void
error(const char *fmt, ...)
{
	va_list ap;
        va_start(ap, fmt);
        vfprintf(stderr, fmt, ap);
        va_end(ap);
	fputc('\n', stderr);
	exit(1);
}

void
syserror(const char *fmt, ...)
{
	va_list ap;
	int e = errno;

        va_start(ap, fmt);
        vfprintf(stderr, fmt, ap);
        va_end(ap);
	fprintf(stderr, ": %s\n", strerror(e));
	       
	exit(1);
}
