#include "driver_env_glue.h"
#include <sys/mman.h>

static size_t inline roundup(size_t a, size_t b){
	return (a + (b-1)) & ~(b-1);
}


int 
get_pinnable_memory(size_t size, mem_handle_t *handle)
{
	void *mem;

	mem = mmap(NULL, roundup(size, pagesize), PROT_READ|PROT_WRITE, MAP_SHARED|MAP_ANONYMOUS, 0, 0);
	if (mem == MAP_FAILED)
		return -1;
	*handle = new_mem_handle(mem, size);
	return 0;
}
