
#include <errno.h>
#include <string.h>
#include "driver_env_glue.h"
#include "usr_pci_map.h"
#include "xmalloc.h"
#include "pci_dma.h"
#include <stdio.h>

int
get_pci_consistent_memory(dma_handle_t dma, size_t sz, mem_handle_t *vaddr, dmabuf_handle_t *busaddr)
{
	struct mapping_info m;
	dmabuf_handle_t x;

	m.size = (unsigned int)sz;
	if (usr_pci_map(dma, USR_ALLOC_CONSISTENT, &m)) {
		fprintf(stderr, "usr_pci_map: %s\n", strerror(errno));
		return -1;
	}

	*vaddr = new_mem_handle(m.virtaddr, sz);

	x = xmalloc(sizeof *x + sizeof x->sglist[0]);
	x->nentries = 1;
	GLUE_DMABUF_ENT_LEN(x, 0) = sz;
	GLUE_DMABUF_ENT_DMAADDR(x, 0) = m.dmaaddr;
	*busaddr = x;
	return 0;
}
