#include "asminclude.h"
#include "config.h"

#if 0
#define PSR_BE_BIT	1
#define PSR_UP_BIT	2
#define PSR_AC_BIT	3
#define PSR_MFL_BIT	4
#define PSR_MFH_BIT	5
#define PSR_IC_BIT	13
#define PSR_I_BIT	14
#define PSR_PK_BIT	15
#define PSR_DT_BIT	17
#define PSR_DFL_BIT	18
#define PSR_DFH_BIT	19
#define PSR_SP_BIT	20
#define PSR_PP_BIT	21
#define PSR_DI_BIT	22
#define PSR_SI_BIT	23
#define PSR_DB_BIT	24
#define PSR_LP_BIT	25
#define PSR_TB_BIT	26
#define PSR_RT_BIT	27
#define PSR_CPL_BITS	32
#define PSR_IS_BIT	34
#define PSR_MC_BIT	35
#define PSR_IT_BIT	36
#define PSR_ID_BIT	37
#define PSR_DA_BIT	38
#define PSR_DD_BIT	39
#define PSR_SS_BIT	40
#define PSR_RI_BITS	41
#define PSR_ED_BIT	43
#define PSR_BN_BIT	44
#define PSR_IA_BIT	45

#define PSR_BE		(1 << PSR_BE_BIT)
#define PSR_UP		(1 << PSR_UP_BIT)
#define PSR_AC		(1 << PSR_AC_BIT)
#define PSR_MFL		(1 << PSR_MFL_BIT)
#define PSR_MFH		(1 << PSR_MFH_BIT)
#define PSR_IC		(1 << PSR_IC_BIT)
#define PSR_I		(1 << PSR_I_BIT)
#define PSR_PK		(1 << PSR_PK_BIT)
#define PSR_DT		(1 << PSR_DT_BIT)
#define PSR_DFL		(1 << PSR_DFL_BIT)
#define PSR_DFH		(1 << PSR_DFH_BIT)
#define PSR_SP		(1 << PSR_SP_BIT)
#define PSR_PP		(1 << PSR_PP_BIT)
#define PSR_DI		(1 << PSR_DI_BIT)
#define PSR_SI		(1 << PSR_SI_BIT)
#define PSR_DB		(1 << PSR_DB_BIT)
#define PSR_LP		(1 << PSR_LP_BIT)
#define PSR_TB		(1 << PSR_TB_BIT)
#define PSR_RT		(1 << PSR_RT_BIT)
#define PSR_CPL_3	(3 << PSR_CPL_BITS)
#define PSR_IS		(1 << PSR_IS_BIT)
#define PSR_MC		(1 << PSR_MC_BIT)
#define PSR_IT		(1 << PSR_IT_BIT)
#define PSR_ID		(1 << PSR_ID_BIT)
#define PSR_DA		(1 << PSR_DA_BIT)
#define PSR_DD		(1 << PSR_DD_BIT)
#define PSR_SS		(1 << PSR_SS_BIT)
#define PSR_ED		(1 << PSR_ED_BIT)
#define PSR_BN		(1 << PSR_BN_BIT)
#define PSR_IA		(1 << PSR_IA_BIT)

#define PTE_P_BIT	0
#define PTE_MA_BITS	2
#define PTE_A_BIT	5
#define PTE_D_BIT	6
#define PTE_PL_BITS	7
#define PTE_AR_BITS	9
#define PTE_PPN_BITS	12
#define PTE_ED_BIT	52

#define PTE_P		(1 << PTE_P_BIT)
#define PTE_A		(1 << PTE_A_BIT)
#define PTE_D		(1 << PTE_D_BIT)
#define PTE_PL_3	(3 << PTE_PL_BITS)
#define PTE_AR_RWX	(3 << PTE_AR_BITS)
#define PTE_AR_RX_RWX	(5 << PTE_AR_BITS)
#define PTE_ED		(1 << PTE_ED_BIT)
#endif

exception_handler_stack:
	.space 8192

	.global _start
_start:
	rsm psr.i|psr.ic
	;;
	movl r3 = exception_handler_stack
	;;
	mov ar.k1 = r3
#ifdef SKI
	mov ar.rsc = 0
	;;
	mov ar.bspstore = r3
	add r12 = 8192-16, r3
	;;
	mov ar.rnat = r0
	;;
	mov ar.rsc = 3
#endif
	;;
	alloc r2 = ar.pfs, 0, 2, 2, 0
	movl gp = __gp
	;;
	mov out0 = r28
	br.call.sptk.many b0=load_kernel
	mov r28 = r9

	.global rfi_to_kernel
rfi_to_kernel:
	mov r16 = (26 << 2)	// 64MB granularity for VM
	movl r17 = 0x38000000
	;;
	mov cr.itir = r16
	movl r18 = (0x38000000|PTE_P|PTE_A|PTE_D|PTE_PL_3|PTE_AR_RX_RWX)
	mov cr.ifa = r17
	;;
	itr.d dtr[r0] = r18
	;;
	itr.i itr[r0] = r18
	;;
	srlz.i
	;;

	/* RFI to kernel */
	movl r16 = ivt
	;;
	mov cr.iva = r16
	movl r17 = (PSR_IC|PSR_I|PSR_DT|PSR_RT|PSR_CPL_3|PSR_IT|PSR_BN|PSR_DB|PSR_PP)
	;;
	mov cr.ipsr = r17
	mov cr.iip = r8
	mov cr.ifs = r0
	;;
	rfi
	;;

	.global reset_system
reset_system:
	rsm psr.i|psr.ic
	;;
	srlz.d
	;;
	movl r16 = do_reset_system
	movl r17 = 0
	;;
	mov cr.iip = r16
	mov cr.ipsr = r17
	mov cr.ifs = r0
	;;
	rfi
	;;

	.global save_bank1
save_bank1:
	mov r16=ar.unat
	add r2=8,r32
	bsw.1
	;;
	st8.spill [r32] = r16, 16
	st8.spill [r2]  = r17, 16
	;;
	st8.spill [r32] = r18, 16
	st8.spill [r2]  = r19, 16
	;;
	st8.spill [r32] = r20, 16
	st8.spill [r2]  = r21, 16
	;;
	st8.spill [r32] = r22, 16
	st8.spill [r2]  = r23, 16
	;;
	st8.spill [r32] = r24, 16
	st8.spill [r2]  = r25, 16
	;;
	st8.spill [r32] = r26, 16
	st8.spill [r2]  = r27, 16
	;;
	st8.spill [r32] = r28, 16
	st8.spill [r2]  = r29, 16
	;;
	st8.spill [r32] = r30
	st8.spill [r2]  = r31
	;;
	mov r8=ar.unat
	bsw.0
	mov ar.unat=r16
	br.ret.sptk.many b0
	;;

	.global load_bank1
load_bank1:
	mov r16=ar.unat
	add r2=8,r32
	bsw.1
	mov ar.unat=r33
	;;
	ld8.fill r16 = [r32], 16
	ld8.fill r17 = [r2],  16
	;;
	ld8.fill r18 = [r32], 16
	ld8.fill r19 = [r2],  16
	;;
	ld8.fill r20 = [r32], 16
	ld8.fill r21 = [r2],  16
	;;
	ld8.fill r22 = [r32], 16
	ld8.fill r23 = [r2],  16
	;;
	ld8.fill r24 = [r32], 16
	ld8.fill r25 = [r2],  16
	;;
	ld8.fill r26 = [r32], 16
	ld8.fill r27 = [r2],  16
	;;
	ld8.fill r28 = [r32], 16
	ld8.fill r29 = [r2],  16
	;;
	ld8.fill r30 = [r32]
	ld8.fill r31 = [r2]
	;;
	bsw.0
	mov ar.unat=r16
	br.ret.sptk.many b0
	;;

	.global ssc
ssc:
	mov r2 = r15
	mov r15 = r36
	break 0x80001
	;;
	mov r15 = r2
	br.ret.sptk.many b0

	.global tpa
tpa:
	/* magic protocol with nested_dtlb_miss */
	mov r8=0x12
	;;
	tpa r8=r32
	br.ret.sptk.many b0
	;;

	.global shrink_frame
shrink_frame:
	alloc r31=ar.pfs,0,0,0,0
	;;
	break 0x80020 /* rfi */
	;;

	.global io_wait
io_wait:
	hint.m @pause
	nop.i 0x0
	nop.i 0x0
	nop.m 0x0
	nop.f 0x0
	br.few io_wait

	.global sample_pmi
sample_pmi:
	ssm psr.ic
	;;
	srlz.d
	;;
	rsm psr.ic
	;;
	srlz.d
	;;
	br.ret.sptk.many b0
	;;

	.global call_pal
call_pal:
	alloc r16=ar.pfs,4,1,0,0
	mov r18=ip
	movl r17=pal
	;;
	ld8 r17=[r17]
	mov loc0=b0
	mov r28=in0
	mov r29=in1
	mov r30=in2
	mov r31=in3
	;;
	add r18=1f-call_pal,r18
	mov b6=r17
	mov b0=r18
	br.sptk.many b6
	;;
1:
	mov b0=loc0
	br.ret.sptk.many b0
	;;

#ifdef DO_PAL_HALT
	.global call_pal_halt
call_pal_halt:
	alloc r16=ar.pfs,0,14,0,0
	mov r18=ip
	movl r17=pal
	;;
	ld8 r17=[r17]
	mov loc12=b6
	;;
	mov b6=r17
	mov loc0=r3
	mov loc1=r9
	mov loc2=r10
	mov loc3=r11
	mov loc4=r14
	mov loc13=b0
	mov loc5=r15
	mov loc6=r27
	mov loc7=r28
	mov loc8=r29
	mov loc9=r30
	mov loc10=r31
	mov loc11=b7
	add r18=1f-call_pal_halt,r18
	;;
	mov r28=29 //PAL_HALT_LIGHT
	mov r29=r0
	mov r30=r0
	mov r31=r0
	mov b0=r18
	br.sptk.many b6
	;;
1:
	rsm psr.ic|psr.i /* why does PAL_HALT_LIGHT come back with ic set ?? */
	;;
	srlz.d
	mov r3=loc0
	mov r9=loc1
	mov b7=loc11
	mov r10=loc2
	mov r11=loc3
	mov r14=loc4
	mov r15=loc5
	mov r27=loc6
	mov b6=loc12
	mov r28=loc7
	mov r29=loc8
	mov r30=loc9
	mov r31=loc10
	mov b0=loc13
	br.ret.sptk.many b0
	;;
#endif

#ifdef DO_FPSWA
	.global call_fpswa
call_fpswa:
#if 0
	mov r17=psr
	movl r16=1f
	;;
	dep r17=0,r17,17,1 // dt
	;;
	dep r17=0,r17,36,1 // it
	;;
	mov cr.iip=r16
	mov cr.ipsr=r17
	mov cr.ifs=r0
	;;
	rfi
	;;
1:
	alloc loc15=ar.pfs,0,16,8,0
	movl r16=fpswa
	mov loc14=r1
	mov loc13=b0
	mov out0=loc0
	;;
	ld8 r17=[r16],8
	mov loc12=b6
	mov out1=loc1
	mov out2=loc2
	mov out3=loc3
	mov out4=loc4
	;;
	ld8 r1=[r16]
	mov b6=r17
	mov out5=loc5
	mov out6=loc6
	mov out7=loc7
	mov loc0=r3
	mov loc1=r9
	mov loc2=r10
	mov loc3=r11
	mov loc4=r14
	mov loc5=r15
	mov loc6=r27
	mov loc7=r28
	mov loc8=r29
	mov loc9=r30
	mov loc10=r31
	mov loc11=b7
	;;
	br.call.sptk.many b0=b6
	mov r3=loc0
	mov r9=loc1
	mov b7=loc11
	mov r10=loc2
	mov r11=loc3
	mov r14=loc4
	mov r15=loc5
	mov r27=loc6
	mov b6=loc12
	mov r28=loc7
	mov r29=loc8
	mov r30=loc9
	mov r31=loc10
	mov b0=loc13
	mov r1=loc14
	mov ar.pfs=loc15

	mov r17=psr
	movl r16=2f
	;;
	dep r17=-1,r17,17,1 // dt
	;;
	dep r17=-1,r17,36,1 // it
	;;
	mov cr.iip=r16
	mov cr.ipsr=r17
	mov cr.ifs=r0
	;;
	rfi
	;;
2:
#endif
	br.ret.sptk.many b0
	;;
#endif

