#include "asminclude.h"
#include "config.h"

	.align 32768
	.global ivt
ivt:

#define FAULT(offset) mov r3=offset; nop.m 0x0; nop.i 0x0;; CCALL(handle_unhandled)

#define p1		r16
#define p2		r17
#define newBSPSTORE	r18
#define newRSC		r19
#define tempRSC		r20
#define tempBSPSTORE	r21
#define tempRNAT	r22

#define savedBSP	r27
#define savedR1		r28
#define savedR2		r29
#define savedR8		r30
#define savedR12	r31
#define savedPFS	loc0
#define savedRSC	loc1
#define savedBSPSTORE	loc2
#define savedRNAT	loc3
#define savedB0		loc4
#define savedPR		loc5
#define savednewBSPSTORE	loc6

#define DEBUG(fn)				\
	/*M*/ nop.m 0x0;			\
	/*I*/ nop.i 0x0;			\
	/*B*/ br.many fn##_debug		\
	;;					\
fn##_debug_return:

/* Aggressively switch register stacks so we can save some of the
   context on the register stack */
#define CCALL_INTERNAL(fn,prsource)		\
	/*M*/ mov newBSPSTORE = ar.k1;		\
	/*M*/ mov tempRSC = ar.rsc;		\
	/*B*/ cover;				\
	/*M*/ mov ar.rsc = 0;			\
	;;					\
	/*M*/ mov tempBSPSTORE = ar.bspstore;	\
	/*I*/ mov savedR1 = r1;			\
	/*M*/ mov tempRNAT = ar.rnat;		\
	/*M*/ mov ar.bspstore = newBSPSTORE;	\
	/*I*/ mov savedR2 = r2;			\
	;;					\
	/*M*/ alloc savedPFS = ar.pfs, 0, 7, 0, 0;	\
	/*M*/ mov ar.rsc = 3;			\
	/*I*/ mov savedRSC = tempRSC;		\
	/*M*/ mov savedBSPSTORE = tempBSPSTORE;	\
	/*M*/ mov savedRNAT = tempRNAT;		\
	/*I*/ mov savedB0 = b0;			\
	;;					\
	/*M*/ mov savedBSP = ar.bsp;		\
	/*LX*/ movl r1=__gp;			\
	/*M*/ mov savedR8 = r8;			\
	/*I*/ mov savedR12 = r12;		\
	/*I*/ add r12 = 8192-16, newBSPSTORE;	\
	/*M*/ mov savednewBSPSTORE=newBSPSTORE;	\
	/*I*/ mov savedPR = prsource;		\
	/*B*/ br.call.sptk.many b0=fn;		\
	;;					\
	/*M*/ sub newRSC = savedBSP, savednewBSPSTORE;	\
	/*M*/ mov tempRSC = savedRSC;		\
	/*I*/ mov ar.pfs = savedPFS;		\
	;;					\
	/*M*/ mov tempRNAT = savedRNAT;		\
	/*I*/ shl newRSC = newRSC,16;		\
	/*I*/ mov b0 = savedB0;			\
	;;					\
	/*M*/ mov ar.rsc = newRSC;		\
	/*A*/ mov tempBSPSTORE = savedBSPSTORE;	\
	/*I*/ mov pr = savedPR, -1;		\
	;;					\
	/*M*/ alloc r8 = ar.pfs, 0, 0, 0, 0;	\
	/*A*/ mov r1 = savedR1;			\
	/*A*/ mov r2 = savedR2;			\
	;;					\
	/*M*/ loadrs;				\
	/*A*/ mov r8 = savedR8;			\
	/*A*/ mov r12 = savedR12;		\
	;;					\
	/*M*/ mov ar.bspstore = tempBSPSTORE;	\
	;;					\
	/*M*/ mov ar.rnat = tempRNAT;		\
	/*M*/ mov ar.rsc = tempRSC;		\
	/*B*/ /* rfi; */			\
	/* ;; */

#define CCALL(fn)  CCALL_INTERNAL(fn, pr)

	.org ivt+0x0000
vhpt_miss:
#ifndef LONG_VHPT
#define rVA		r16
#define rRR		r17
#define rHash		r18
#define rTag		r19
#define rTag1		r20
#define rTag2		r21
#define rEntry		r22
#define rPTE		r23
#define rIHA		r24
#define rSavedPR	r26
#define rTemp		r27
#define pMatch2		p6
#define pNotMatch2	p7
#define pMatchOR	p8
#define pNotMatchOR	p9

/*0*//*MLX*/	mov rIHA=cr.iha
		movl rEntry=pgd_hash_table+8
     /*.LX*/	mov rVA=cr.ifa
		movl rPTE=_vhpt+(PTE_AR_RW|PTE_PL_3|PTE_D|PTE_A|PTE_P)
/*MI0;I0;*/	mov rTemp=4095 // (assumes 4096 entry HT)
		mov rSavedPR=pr
		;;
/*5*/		shr rTag=rIHA,12 // PAGE_SHIFT
   /*M;MI0.;*/	mov rRR=rr[rIHA]
		;;
/*10*/		and rTemp=rTag,rTemp
		shr rHash=rRR,(32-12) // (assumes 4096 entry HT)
		;;
/*11*//*MI0;I0*/	xor rHash=rTemp,rHash
		extr.u rTemp=rTag,31,1
		;;
/* XXX TEMP */
		/* shl rTemp=rTemp,11
		;; */
/*12*/		shl rTag=rTag,32
     /*M;MI0;*/ xor rHash=rTemp,rHash
		;;
/*13*/		shladd rEntry=rHash,4,rEntry
		dep rPTE=rHash,rPTE,13,12 // (assumes 4096 entry HT)
		;;
/*14*//*MMI0;*/	ld8 rTag2=[rEntry],-8
		mov cr.ifa=rIHA
		shrp rTag=rRR,rTag,32
		;;
/*15*//*MII;*/	ld8 rTag1=[rEntry]
		cmp.eq pMatch2,pNotMatch2=rTag2,rTag
		nop.i 0x0
		;;
/*16*//*MMI;*/
(pMatch2)	add rPTE=4096,rPTE
(pMatch2)	cmp.eq pMatchOR,pNotMatchOR=r0,r0
(pNotMatch2)	cmp.eq pMatchOR,pNotMatchOR=rTag1,rTag
		;;
/*17*//*MBB*/
(pMatchOR)	itc.d rPTE
(pNotMatchOR)	mov cr.ifa=rVA
(pNotMatchOR)	br.spnt.many 1f
		mov pr=rSavedPR,-1
		rfi
		;;
1:
		CCALL_INTERNAL(handle_vhpt_miss,rSavedPR)
#else
	FAULT(1)
#endif
	rfi
	;;

	.org ivt+0x0400
itlb_miss:
	/* this needs to be enabled for short VHPT as well (see
         * comment in handle_itlb_miss) */
	CCALL(handle_itlb_miss)
	rfi
	;;

	.org ivt+0x0800
dtlb_miss:
#ifdef LONG_VHPT
	CCALL(handle_dtlb_miss)
#else
	FAULT(0x0800)
#endif
	rfi
	;;

	.org ivt+0x0c00
alt_itlb_miss:
	FAULT(0x0c00)
	rfi
	;;

	.org ivt+0x1000
alt_dtlb_miss:
	FAULT(0x1000)
	rfi
	;;

	.org ivt+0x1400
nested_dtlb_miss:
	/* magic protocol with tpa */
	cmp.eq p6,p0=0x12,r8
	;;
(p6)	mov r8=0
(p6)	br.ret.sptk.many b0
	;;
#ifdef SKI
	break 0
#else
#ifdef VGA_DEBUG
	rsm psr.dt
	;;
	srlz.d
	;;
	mov r17=b0
	movl r16=0x80000000000b8000
	;;
	mov r19=16
	br.call.sptk.many b0=print
	;;
#endif
	//ssm psr.i|psr.ic|psr.dt
	;;
1:	br.few 1b
	;;
#endif

	.org ivt+0x1800
ikey_miss:
	FAULT(0x1800)
	rfi
	;;

	.org ivt+0x1c00
dkey_miss:
	FAULT(0x1c00)
	rfi
	;;

	.org ivt+0x2000
dirty_bit:
	CCALL(handle_dirty_bit)
	rfi
	;;

	.org ivt+0x2400
iaccess_bit:
	CCALL(handle_iaccess_bit)
	rfi
	;;

	.org ivt+0x2800
daccess_bit:
	CCALL(handle_daccess_bit)
	rfi
	;;

	.org ivt+0x2c00
break_fault:
	CCALL(handle_break)
	rfi
	;;

	.org ivt+0x3000
interrupt:
	CCALL(handle_interrupt)
	rfi
	;;

	.org ivt+0x5000
page_not_present:
#ifndef LONG_VHPT
	mov r16=cr.isr
	mov r17=pr
	cmp.eq p6,p0=r0,r0
	;;
	tbit.nz.and p6,p0=r16,39 //ni
	cmp.eq.and p6,p0=0x12,r8
	;;
(p6)	mov r8=0
(p6)	br.ret.spnt.many b0
	;;
#endif
	CCALL_INTERNAL(handle_page_not_present,r17)
	rfi
	;;

#if 0
	.org ivt+0x5100
key_permission:
	FAULT(0x5100)
	rfi
	;;
#endif

	.org ivt+0x5200
iaccess_rights:
	CCALL(handle_iaccess_rights)
	rfi
	;;

	.org ivt+0x5300
daccess_rights:
	CCALL(handle_daccess_rights)
	rfi
	;;

	.org ivt+0x5400
general_exception:
	CCALL(handle_general_exception)
	rfi
	;;

	.org ivt+0x5500
disabled_fp:
	CCALL(handle_disabled_fp)
	rfi
	;;

	.org ivt+0x5600
nat_consumption:
	FAULT(0x5600)
	rfi
	;;

	.org ivt+0x5700
speculation_vector:
#ifdef DSM
	mov r18=cr.iim
	;;
	mov r17=cr.iip
	shl r18=r18,43			// put sign bit in position (43=64-21)
	;;

	mov r16=cr.ipsr
	shr r18=r18,39			// sign extend (39=43-4)
	;;

	add r17=r17,r18			// now add the offset
	;;
	mov cr.iip=r17
	dep r16=0,r16,41,2		// clear EI
	;;

	mov cr.ipsr=r16
	;;
#else
	CCALL(handle_speculation)
#endif
	rfi
	;;

	.org ivt+0x5900
debug_vector:
	CCALL(handle_debug)
	rfi
	;;

	.org ivt+0x5a00
unaligned_reference:
	CCALL(handle_unaligned)
	rfi
	;;

	.org ivt+0x5b00
unsupported_data_reference:
	FAULT(0x5b00)
	rfi
	;;

	.org ivt+0x5c00
fp_fault:
#ifdef DO_FPSWA
	CCALL(handle_fp_fault)
#else
	FAULT(0x5c00)
#endif
	rfi
	;;

	.org ivt+0x5d00
fp_trap:
#ifdef DO_FPSWA
	CCALL(handle_fp_trap)
#else
	FAULT(0x5d00)
#endif
	rfi
	;;

	.org ivt+0x5e00
lower_privilege_transfer_trap:
	FAULT(0x5e00)
	rfi
	;;

	.org ivt+0x5f00
taken_branch_trap:
	FAULT(0x5f00)
	rfi
	;;

	.org ivt+0x6000
single_step_trap:
#ifdef THRASH_PROTECTION
	CCALL(handle_single_step)
#else
	FAULT(0x6000)
#endif
	rfi
	;;

#ifdef VGA_DEBUG
print:
	shr.u r18 = r17, 60
	;;
	cmp.le p6,p7 = 10, r18
	;;
(p6)	add r18 = 'a'-10, r18
(p7)	add r18 = '0', r18
	;;
	st1 [r16] = r18
	shl r17 = r17, 4
	add r19 = -1, r19
	add r16 = 2, r16
	;;
	cmp.ne p6,p0 = r0, r19
(p6)	br.sptk.many print
	;;
	br.ret.sptk.many b0
	;;
#endif
