#include "vm.h"
#include "profile_dsm.h"

unsigned long start_time;
struct sample sample_buffer[2][NSAMPLES];
unsigned int sample;
unsigned int buffer_num;

void
profile_dsm_flush(void)
{
	struct request request;
	request.type = IPC_PROFILE;
	request.profile.start = start_time;
	start_time = request.profile.end = read_itc();
	request.profile.count = sample;
	ipc_send_page(62, &request, (unsigned long)sample_buffer[buffer_num], sample * sizeof(struct sample), DATA_AREA_STATIC);
	sample = 0;
	buffer_num ^= 1;
}

#if 0
void
profile_dsm(unsigned long ip, unsigned long mpfn, unsigned long rel_time, unsigned long wait_time, unsigned char type, int is_write, access_type_t access_type, unsigned int pending)
{
	struct sample *s = &sample_buffer[buffer_num][sample++];
	s->ip = ip;
	s->mpfn = mpfn;
	s->rel_time = rel_time;
	s->wait_time = wait_time;
	s->type = type;
	s->is_write = is_write;
	s->access_type = access_type;
	s->pending = pending;
	if (sample == NSAMPLES)
		profile_dsm_flush();
}
#endif

void
profile_fetch(unsigned long start_time, unsigned int pending, mpfn_t mpfn, boolean is_write, uint8_t access_type, node_t sent_to, node_t rcvd_from, boolean rcvd_data)
{
	unsigned long end_time = read_itc();
	unsigned long ip = read_iip();
	struct sample *s = &sample_buffer[buffer_num][sample++];

	s->ip = ip;
	s->mpfn = mpfn;
	s->wait_time = end_time - start_time;
	s->type = IPC_FETCH;
	s->pending = pending;
	s->fetch.is_write = is_write;
	s->fetch.access_type = access_type;
	s->fetch.sent_to = sent_to;
	s->fetch.rcvd_from = rcvd_from;
	s->fetch.rcvd_data = rcvd_data;
	if (sample == NSAMPLES)
		profile_dsm_flush();

	if ((ip >> 61) >= 5)
		CORE_STATS_ADD(ipc_wait_time_k, end_time - start_time);
	else
		CORE_STATS_ADD(ipc_wait_time_u, end_time - start_time);
}

void
profile_invalidate(unsigned long start_time, unsigned int pending, mpfn_t mpfn, copyset_t copyset)
{
	unsigned long end_time = read_itc();
	unsigned long ip = read_iip();
	struct sample *s = &sample_buffer[buffer_num][sample++];

	s->ip = read_iip();
	s->mpfn = mpfn;
	s->wait_time = end_time - start_time;
	s->type = IPC_INVALIDATE;
	s->pending = pending;
	s->invalidate.copyset = copyset;
	if (sample == NSAMPLES)
		profile_dsm_flush();

	if ((ip >> 61) >= 5)
		CORE_STATS_ADD(ipc_wait_time_k, end_time - start_time);
	else
		CORE_STATS_ADD(ipc_wait_time_u, end_time - start_time);
}

